// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- // 
// C++ Header File Name: gxs_b64.h
// C++ Compiler Used: MSVC, BCC32, GCC, HPUX aCC, SOLARIS CC
// Produced By: glNET Software
// File Creation Date: 01/25/2000
// Date Last Modified: 07/31/2001
// Copyright (c) 2001 glNET Software
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.
 
This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  
USA

Standalone functions used for base 64 password encryption and
decoding.
*/
// ----------------------------------------------------------- // 
#ifndef __GX_BASE64_HPP__
#define __GX_BASE64_HPP__

#include "gxdlcode.h"

#include "gxstring.h"

GXDLCODE_API int gxsCalculateBase64Length(int len);
GXDLCODE_API void gxsBase64Encode(const char *s, char *strbuf, int length);
GXDLCODE_API int gxsBase64ConvertToNumber(unsigned char c);
GXDLCODE_API void gxsBase64Decode(const char *s, char *strbuf);
GXDLCODE_API int gxsBasicAuthenticationEncode(const char *user, const char *passwd,
					      const char *header, gxString &wwwauth);
GXDLCODE_API void gxsBasicAuthenticationDecode(const gxString &wwwauth, gxString &user,
					       gxString &passwd);

#endif // __GX_BASE64_HPP__
// ----------------------------------------------------------- //
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //
