// ------------------------------- //
// -------- Start of File -------- //
// ------------------------------- //
// ----------------------------------------------------------- //
// C++ Header File Name: leaktest.h 
// Compiler Used: MSVC 6.0 SR3
// File Creation Date: 11/09/2000 
// Date Last Modified: 07/31/2001
// ----------------------------------------------------------- // 
// ---------- Include File Description and Details  ---------- // 
// ----------------------------------------------------------- // 
/*
THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND.
THE ENTIRE RISK OF THE QUALITY AND PERFORMANCE OF THIS SOFTWARE
IS WITH YOU. SHOULD ANY ELEMENT OF THIS SOFTWARE PROVE DEFECTIVE,
YOU WILL ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR, OR
CORRECTION.

Code used to monitor memory leaks within an MSVC application.
This program was taken from the Visual C++ Debug Routines
example program. The leak test functions will print an error
message to the console if the end of the application attempts to
overwrite the end of an allocated buffer or if any memory leaks
occur. To use this code the InitLeakTest() function must be called
in the program's main thread of execution. Additionally the
program must be compiled with the /MDd compiler flag the /MTd
compiler flag for multi-threaded applications.
*/
// ----------------------------------------------------------- //  
#ifndef __GX_LEAK_TEST_HPP__
#define __GX_LEAK_TEST_HPP__

#include "gxdlcode.h"

// NOTE: This macro must defined in the MSVC project makefile 
#if defined(__MSVC_DEBUG__)
#include <iostream.h>
#include <crtdbg.h>

#ifndef _CRTDBG_MAP_ALLOC 
#define _CRTDBG_MAP_ALLOC 
#endif

#endif // __MSVC_DEBUG__

GXDLCODE_API void OutputHeading(const char *explanation);
GXDLCODE_API void InitLeakTest();


#endif // __GX_LEAK_TEST_HPP__
// ----------------------------------------------------------- // 
// ------------------------------- //
// --------- End of File --------- //
// ------------------------------- //




