#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for the MSVC gxcode dynamic link library
# C/C++ Compiler Used: Microsoft Visual C/C++ 6.0 SP3 
# Produced By: glNET Software
# File Creation Date: 05/25/2001
# Date Last Modified: 07/31/2001
# --------------------------------------------------------------- 
# Setup library configuration
!IF "$(FINAL)" == ""
FINAL = 0 # Default to debug configuration
!MESSAGE No library configuration specified. Defaulting to debug configuration.
!ENDIF

!IF "$(64BITCFG)" == ""
64BITCFG = 0 # Default to 32-bit configuration
!MESSAGE No 64-bit configuration specified. Defaulting to 32-bit configuration.
!ENDIF

# Setup gxcode DLL library paths
GCODE_LIB_PATH = .. 
GLIB_INCLUDE_PATH = include$(PATHSEP)
GLIB_SRC_PATH = src$(PATHSEP)

!include msvc.env

# Define a name for the static library
!IF "$(64BITCFG)" == "1" && "$(FINAL)" == "1"
PROJECT = gxcode64
!ENDIF
!IF "$(64BITCFG)" == "1" && "$(FINAL)" == "0"
PROJECT = gxcode64d
!ENDIF
!IF "$(64BITCFG)" == "0" && "$(FINAL)" == "1"
PROJECT = gxcode32
!ENDIF
!IF "$(64BITCFG)" == "0" && "$(FINAL)" == "0"
PROJECT = gxcode32d
!ENDIF

# Add compiler and linker flags needed to make the DLL
!IF "$(FINAL)" == "1"  # No debugging information
OUTDIR = release
COMPILE_FLAGS = $(COMPILE_FLAGS) /D "_MBCS" /D "_USRDLL" \
/D "GXDLCODE_EXPORTS" \
/Fp"./$(OUTDIR)\$(PROJECT).pch" /YX /Fo"./$(OUTDIR)\\" \
/Fd"./$(OUTDIR)\\" # /FD # MSVC 6.0 SP3 flag
LINKER_FLAGS = $(LINKER_FLAGS) /dll \
/pdb:"./$(OUTDIR)\$(PROJECT).pdb" \
/out:"./$(OUTDIR)\$(PROJECT)$(SHAREDLIB_EXT)" \
/implib:"./$(OUTDIR)\$(PROJECT).lib" 
!ELSE # Making debug DLL
OUTDIR = debug
COMPILE_FLAGS = $(COMPILE_FLAGS) /D "_MBCS" /D "_USRDLL" \
/D "GXDLCODE_EXPORTS" \
/Fp"./$(OUTDIR)\\$(PROJECT).pch" /YX /Fo"./$(OUTDIR)\\" \
/Fd"./$(OUTDIR)\\" # /FD /GZ # MSVC 6.0 SP3 flags
LINKER_FLAGS = $(LINKER_FLAGS) /dll \
/pdb:"./$(OUTDIR)\$(PROJECT).pdb" \
/out:"./$(OUTDIR)\$(PROJECT)$(SHAREDLIB_EXT)" \
/implib:"./$(OUTDIR)\$(PROJECT)$(LIB_EXT)" \
/pdbtype:sept
!ENDIF

# Build dependency rules
# ===============================================================
STDAFX_DEP = $(GLIB_INCLUDE_PATH)gxdlincs.h \
	$(GLIB_INCLUDE_PATH)stdafx.h

GXDLCODE_DEP = $(GLIB_INCLUDE_PATH)gxdlincs.h \
	$(GLIB_INCLUDE_PATH)stdafx.h \
	$(GLIB_INCLUDE_PATH)gxdlcode.h

ASPRINT_DEP = $(GLIB_INCLUDE_PATH)asprint.h

BSTREEI_DEP = $(GLIB_INCLUDE_PATH)bstnode.h \
	$(GLIB_INCLUDE_PATH)gxbstree.h \
	$(GLIB_INCLUDE_PATH)bstreei.h

BTNODE_DEP = $(GLIB_INCLUDE_PATH)btnode.h \
	$(GLIB_INCLUDE_PATH)keytypes.h \
	$(GLIB_INCLUDE_PATH)dbasekey.h \
	$(GLIB_INCLUDE_PATH)gxdtypes.h \
	$(GLIB_INCLUDE_PATH)gxheader.h \
	$(GLIB_INCLUDE_PATH)gxdfptr.h \
	$(GLIB_INCLUDE_PATH)gxderror.h \
	$(GLIB_INCLUDE_PATH)gxd_ver.h \
	$(GLIB_INCLUDE_PATH)gxint32.h \
	$(GLIB_INCLUDE_PATH)gxdbase.h \
	$(GLIB_INCLUDE_PATH)gxcrc32.h \
	$(GLIB_INCLUDE_PATH)gxuint32.h

BTSTACK_DEP = $(GLIB_INCLUDE_PATH)btstack.h \
	$(GLIB_INCLUDE_PATH)keytypes.h \
	$(GLIB_INCLUDE_PATH)gxdtypes.h \
	$(GLIB_INCLUDE_PATH)gxheader.h \
	$(GLIB_INCLUDE_PATH)gxdfptr.h \
	$(GLIB_INCLUDE_PATH)gxderror.h \
	$(GLIB_INCLUDE_PATH)gxd_ver.h \
	$(GLIB_INCLUDE_PATH)gxint32.h \
	$(GLIB_INCLUDE_PATH)gxdbase.h \
	$(GLIB_INCLUDE_PATH)gxcrc32.h \
	$(GLIB_INCLUDE_PATH)gxuint32.h

CDATE_DEP = $(GLIB_INCLUDE_PATH)gxdtypes.h \
	$(GLIB_INCLUDE_PATH)gxint16.h \
	$(GLIB_INCLUDE_PATH)cdate.h

DBASEKEY_DEP = $(GLIB_INCLUDE_PATH)dbasekey.h \
	$(GLIB_INCLUDE_PATH)keytypes.h \
	$(GLIB_INCLUDE_PATH)gxdtypes.h \
	$(GLIB_INCLUDE_PATH)gxheader.h \
	$(GLIB_INCLUDE_PATH)gxdfptr.h \
	$(GLIB_INCLUDE_PATH)gxderror.h \
	$(GLIB_INCLUDE_PATH)gxd_ver.h \
	$(GLIB_INCLUDE_PATH)gxint32.h \
	$(GLIB_INCLUDE_PATH)gxdbase.h \
	$(GLIB_INCLUDE_PATH)gxcrc32.h \
	$(GLIB_INCLUDE_PATH)gxuint32.h

DEVCACHE_DEP =  $(GLIB_INCLUDE_PATH)devcache.h \
	$(GLIB_INCLUDE_PATH)devtypes.h \
	$(GLIB_INCLUDE_PATH)membuf.h \
	$(GLIB_INCLUDE_PATH)memblock.h

DFILEB_DEP = $(GLIB_INCLUDE_PATH)dfileb.h

EDS101_DEP = $(GLIB_INCLUDE_PATH)eds101.h \
	$(GLIB_INCLUDE_PATH)edst101.h

EDS201_DEP = $(GLIB_INCLUDE_PATH)eds201.h \
	$(GLIB_INCLUDE_PATH)gxdtypes.h \
	$(GLIB_INCLUDE_PATH)gxuint16.h

EDSCFG_DEF = $(GLIB_INCLUDE_PATH)eds101.h \
	$(GLIB_INCLUDE_PATH)edscfg.h

EHANDLER_DEP = $(GLIB_INCLUDE_PATH)ehandler.h

FSTRING_DEP = $(GLIB_INCLUDE_PATH)fstring.h \
	$(GLIB_INCLUDE_PATH)strutil.h

FUTILS_DEP = $(GLIB_INCLUDE_PATH)futils.h

GPERSIST_DEP = $(GLIB_INCLUDE_PATH)pod.h \
	$(GLIB_INCLUDE_PATH)gpersist.h \
	$(GLIB_INCLUDE_PATH)gxbtree.h \
	$(GLIB_INCLUDE_PATH)keytypes.h \
	$(GLIB_INCLUDE_PATH)dbasekey.h \
	$(GLIB_INCLUDE_PATH)btnode.h \
	$(GLIB_INCLUDE_PATH)btstack.h \
	$(GLIB_INCLUDE_PATH)gxdtypes.h \
	$(GLIB_INCLUDE_PATH)gxheader.h \
	$(GLIB_INCLUDE_PATH)gxdfptr.h \
	$(GLIB_INCLUDE_PATH)gxderror.h \
	$(GLIB_INCLUDE_PATH)gxd_ver.h \
	$(GLIB_INCLUDE_PATH)gxint32.h \
	$(GLIB_INCLUDE_PATH)gxdbase.h \
	$(GLIB_INCLUDE_PATH)gxcrc32.h \
	$(GLIB_INCLUDE_PATH)gxuint32.h

GTHREADT_DEP = $(GLIB_INCLUDE_PATH)thrtypes.h \
	$(GLIB_INCLUDE_PATH)gthreadt.h \
	$(GLIB_INCLUDE_PATH)gxthread.h \
	$(GLIB_INCLUDE_PATH)thrpool.h \
	$(GLIB_INCLUDE_PATH)gxcond.h \
	$(GLIB_INCLUDE_PATH)gxmutex.h \
	$(GLIB_INCLUDE_PATH)thelpers.h

GXBTREE_DEP = $(GLIB_INCLUDE_PATH)gxbtree.h \
	$(GLIB_INCLUDE_PATH)keytypes.h \
	$(GLIB_INCLUDE_PATH)dbasekey.h \
	$(GLIB_INCLUDE_PATH)btnode.h \
	$(GLIB_INCLUDE_PATH)btstack.h \
	$(GLIB_INCLUDE_PATH)gxdtypes.h \
	$(GLIB_INCLUDE_PATH)gxheader.h \
	$(GLIB_INCLUDE_PATH)gxdfptr.h \
	$(GLIB_INCLUDE_PATH)gxderror.h \
	$(GLIB_INCLUDE_PATH)gxd_ver.h \
	$(GLIB_INCLUDE_PATH)gxint32.h \
	$(GLIB_INCLUDE_PATH)gxdbase.h \
	$(GLIB_INCLUDE_PATH)gxcrc32.h \
	$(GLIB_INCLUDE_PATH)gxuint32.h

GXCOND_DEP = $(GLIB_INCLUDE_PATH)thrtypes.h \
	$(GLIB_INCLUDE_PATH)gxcond.h \
	$(GLIB_INCLUDE_PATH)thelpers.h \
	$(GLIB_INCLUDE_PATH)gxmutex.h

GXCONFIG_DEP = $(GLIB_INCLUDE_PATH)ustring.h \
	$(GLIB_INCLUDE_PATH)gxconfig.h \
	$(GLIB_INCLUDE_PATH)gxlistb.h \
	$(GLIB_INCLUDE_PATH)gxstring.h

GXCRC32_DEP = $(GLIB_INCLUDE_PATH)gxcrc32.h \
	$(GLIB_INCLUDE_PATH)gxcrctab.h

GXDATAGM_DEP = $(GLIB_INCLUDE_PATH)gxsocket.h \
	$(GLIB_INCLUDE_PATH)gxstypes.h \
	$(GLIB_INCLUDE_PATH)gxdatagm.h \
	$(GLIB_INCLUDE_PATH)gxheader.h \
	$(GLIB_INCLUDE_PATH)gxdtypes.h \
	$(GLIB_INCLUDE_PATH)gxd_ver.h \
	$(GLIB_INCLUDE_PATH)gxint32.h

GXDBASE_DEP = $(GLIB_INCLUDE_PATH)gxdtypes.h \
	$(GLIB_INCLUDE_PATH)gxheader.h \
	$(GLIB_INCLUDE_PATH)gxdfptr.h \
	$(GLIB_INCLUDE_PATH)gxderror.h \
	$(GLIB_INCLUDE_PATH)gxd_ver.h \
	$(GLIB_INCLUDE_PATH)gxint32.h \
	$(GLIB_INCLUDE_PATH)gxdbase.h \
	$(GLIB_INCLUDE_PATH)gxcrc32.h \
	$(GLIB_INCLUDE_PATH)gxuint32.h

GXDERROR_DEP = $(GLIB_INCLUDE_PATH)gxderror.h

GXDFP64_DEP = $(GLIB_INCLUDE_PATH)gxdtypes.h \
	$(GLIB_INCLUDE_PATH)gxdfp64.h \
	$(GLIB_INCLUDE_PATH)gxdtyp64.h \
	$(GLIB_INCLUDE_PATH)gxheader.h \
	$(GLIB_INCLUDE_PATH)gxd_ver.h \
	$(GLIB_INCLUDE_PATH)gxint32.h \
	$(GLIB_INCLUDE_PATH)gxint64.h \
	$(GLIB_INCLUDE_PATH)gxuint64.h \
	$(GLIB_INCLUDE_PATH)gxuint32.h

GXDFPTR_DEP = $(GLIB_INCLUDE_PATH)gxdtypes.h \
	$(GLIB_INCLUDE_PATH)gxdfptr.h \
	$(GLIB_INCLUDE_PATH)gxheader.h \
	$(GLIB_INCLUDE_PATH)gxd_ver.h \
	$(GLIB_INCLUDE_PATH)gxint32.h \
	$(GLIB_INCLUDE_PATH)gxuint32.h

GXDSTATS_DEP = $(GLIB_INCLUDE_PATH)gxdtypes.h \
	$(GLIB_INCLUDE_PATH)gxheader.h \
	$(GLIB_INCLUDE_PATH)gxdfptr.h \
	$(GLIB_INCLUDE_PATH)gxderror.h \
	$(GLIB_INCLUDE_PATH)gxd_ver.h \
	$(GLIB_INCLUDE_PATH)gxint32.h \
	$(GLIB_INCLUDE_PATH)gxdbase.h \
	$(GLIB_INCLUDE_PATH)gxcrc32.h \
	$(GLIB_INCLUDE_PATH)gxuint32.h \
	$(GLIB_INCLUDE_PATH)gxdstats.h

GXFLOAT_DEP = $(GLIB_INCLUDE_PATH)gxdtypes.h \
	$(GLIB_INCLUDE_PATH)gxfloat.h

GXINT16_DEP = $(GLIB_INCLUDE_PATH)gxdtypes.h \
	$(GLIB_INCLUDE_PATH)gxint16.h

GXINT32_DEP = $(GLIB_INCLUDE_PATH)gxdtypes.h \
	$(GLIB_INCLUDE_PATH)gxint32.h

GXINT64_DEP = $(GLIB_INCLUDE_PATH)gxdtypes.h \
	$(GLIB_INCLUDE_PATH)gxdtyp64.h \
	$(GLIB_INCLUDE_PATH)gxint64.h

GXIP32_DEP = $(GLIB_INCLUDE_PATH)gxip32.h

GXLISTB_DEP = $(GLIB_INCLUDE_PATH)gxlistb.h

GXMAC48_DEP = $(GLIB_INCLUDE_PATH)gxmac48.h

GXMUTEX_DEP = $(GLIB_INCLUDE_PATH)thrtypes.h \
	$(GLIB_INCLUDE_PATH)gxmutex.h \
	$(GLIB_INCLUDE_PATH)thelpers.h

GXSCOMM_DEP = $(GLIB_INCLUDE_PATH)gxscomm.h

GXSEMA_DEP = $(GLIB_INCLUDE_PATH)thrtypes.h \
	$(GLIB_INCLUDE_PATH)gxsema.h \
	$(GLIB_INCLUDE_PATH)thelpers.h

GXSFTP_DEP = $(GLIB_INCLUDE_PATH)gxsocket.h \
	$(GLIB_INCLUDE_PATH)gxstypes.h \
	$(GLIB_INCLUDE_PATH)gxsftp.h

GXSHTML_DEP = $(GLIB_INCLUDE_PATH)gxshtml.h \
	$(GLIB_INCLUDE_PATH)gxstring.h \
	$(GLIB_INCLUDE_PATH)ustring.h \
	$(GLIB_INCLUDE_PATH)membuf.h \
	$(GLIB_INCLUDE_PATH)gxlist.h \
	$(GLIB_INCLUDE_PATH)dfileb.h

GXSHTTP_DEP = $(GLIB_INCLUDE_PATH)ustring.h \
	$(GLIB_INCLUDE_PATH)gxlist.h \
	$(GLIB_INCLUDE_PATH)gxstring.h \
	$(GLIB_INCLUDE_PATH)gxshttp.h

GXSHTTPC_DEP =  $(GLIB_INCLUDE_PATH)ustring.h \
	$(GLIB_INCLUDE_PATH)gxlist.h \
	$(GLIB_INCLUDE_PATH)gxstring.h \
	$(GLIB_INCLUDE_PATH)gxsocket.h \
	$(GLIB_INCLUDE_PATH)gxstypes.h \
	$(GLIB_INCLUDE_PATH)devcache.h \
	$(GLIB_INCLUDE_PATH)memblock.h \
	$(GLIB_INCLUDE_PATH)devtypes.h \
	$(GLIB_INCLUDE_PATH)membuf.h \
	$(GLIB_INCLUDE_PATH)gxs_b64.h \
	$(GLIB_INCLUDE_PATH)gxshttp.h \
	$(GLIB_INCLUDE_PATH)gxshttpc.h \
	$(GLIB_INCLUDE_PATH)gxsurl.h

GXSMTP_DEP = $(GLIB_INCLUDE_PATH)gxsocket.h \
	$(GLIB_INCLUDE_PATH)gxstypes.h \
	$(GLIB_INCLUDE_PATH)gxsmtp.h

GXSOCKET_DEP = $(GLIB_INCLUDE_PATH)gxsocket.h \
	$(GLIB_INCLUDE_PATH)gxstypes.h

GXSPING_DEP = $(GLIB_INCLUDE_PATH)gxsocket.h \
	$(GLIB_INCLUDE_PATH)gxstypes.h \
	$(GLIB_INCLUDE_PATH)gxsutils.h \
	$(GLIB_INCLUDE_PATH)gxsping.h

GXSPOP3_DEP = $(GLIB_INCLUDE_PATH)gxsocket.h \
	$(GLIB_INCLUDE_PATH)gxstypes.h \
	$(GLIB_INCLUDE_PATH)gxspop3.h

GXSTREAM_DEP = $(GLIB_INCLUDE_PATH)gxsocket.h \
	$(GLIB_INCLUDE_PATH)gxstypes.h \
	$(GLIB_INCLUDE_PATH)gxstream.h \
	$(GLIB_INCLUDE_PATH)gxheader.h \
	$(GLIB_INCLUDE_PATH)gxdtypes.h \
	$(GLIB_INCLUDE_PATH)gxd_ver.h \
	$(GLIB_INCLUDE_PATH)gxint32.h \
	$(GLIB_INCLUDE_PATH)gxuint32.h

GXSURL_DEP = $(GLIB_INCLUDE_PATH)gxsurl.h \
	$(GLIB_INCLUDE_PATH)ustring.h \
	$(GLIB_INCLUDE_PATH)gxstring.h

GXSUTILS_DEP = $(GLIB_INCLUDE_PATH)gxsocket.h \
	$(GLIB_INCLUDE_PATH)gxstypes.h \
	$(GLIB_INCLUDE_PATH)gxsutils.h

GXS_B64_DEP = $(GLIB_INCLUDE_PATH)ustring.h \
	$(GLIB_INCLUDE_PATH)gxstring.h \
	$(GLIB_INCLUDE_PATH)gxs_b64.h

GXTELNET_DEP = $(GLIB_INCLUDE_PATH)gxsocket.h \
	$(GLIB_INCLUDE_PATH)gxstypes.h \
	$(GLIB_INCLUDE_PATH)gxtelnet.h

GXTHREAD_DEP = $(GLIB_INCLUDE_PATH)thrtypes.h \
	$(GLIB_INCLUDE_PATH)gxthread.h \
	$(GLIB_INCLUDE_PATH)gthreadt.h \
	$(GLIB_INCLUDE_PATH)thrapiw.h \
	$(GLIB_INCLUDE_PATH)thrpool.h

GXUINT16_DEP = $(GLIB_INCLUDE_PATH)gxdtypes.h \
	$(GLIB_INCLUDE_PATH)gxuint16.h

GXUINT32_DEP = $(GLIB_INCLUDE_PATH)gxdtypes.h \
	$(GLIB_INCLUDE_PATH)gxuint32.h

GXUINT64_DEP = $(GLIB_INCLUDE_PATH)gxdtypes.h \
	$(GLIB_INCLUDE_PATH)gxdtyp64.h \
	$(GLIB_INCLUDE_PATH)gxuint64.h

HTMLDRV_DEP = $(GLIB_INCLUDE_PATH)htmldrv.h 

HTTPGRAB_DEP =  $(GLIB_INCLUDE_PATH)ustring.h \
	$(GLIB_INCLUDE_PATH)gxlist.h \
	$(GLIB_INCLUDE_PATH)gxstring.h \
	$(GLIB_INCLUDE_PATH)gxsocket.h \
	$(GLIB_INCLUDE_PATH)gxstypes.h \
	$(GLIB_INCLUDE_PATH)devcache.h \
	$(GLIB_INCLUDE_PATH)memblock.h \
	$(GLIB_INCLUDE_PATH)devtypes.h \
	$(GLIB_INCLUDE_PATH)membuf.h \
	$(GLIB_INCLUDE_PATH)gxs_b64.h \
	$(GLIB_INCLUDE_PATH)gxshttp.h \
	$(GLIB_INCLUDE_PATH)gxshttpc.h \
	$(GLIB_INCLUDE_PATH)gxsurl.h \
	$(GLIB_INCLUDE_PATH)gxshtml.h

LEAKTEST_DEP = $(GLIB_INCLUDE_PATH)leaktest.h

LOGFILE_DEP = $(GLIB_INCLUDE_PATH)logfile.h \
	$(GLIB_INCLUDE_PATH)ostrbase.h 

MEMBLOCK_DEP = $(GLIB_INCLUDE_PATH)memblock.h

MEMBUF_DEP = $(GLIB_INCLUDE_PATH)membuf.h

OSTRBASE_DEP = $(GLIB_INCLUDE_PATH)ostrbase.h 

POD_DEP = $(GLIB_INCLUDE_PATH)pod.h \
	$(GLIB_INCLUDE_PATH)gxbtree.h \
	$(GLIB_INCLUDE_PATH)keytypes.h \
	$(GLIB_INCLUDE_PATH)dbasekey.h \
	$(GLIB_INCLUDE_PATH)btnode.h \
	$(GLIB_INCLUDE_PATH)btstack.h \
	$(GLIB_INCLUDE_PATH)gxdtypes.h \
	$(GLIB_INCLUDE_PATH)gxheader.h \
	$(GLIB_INCLUDE_PATH)gxdfptr.h \
	$(GLIB_INCLUDE_PATH)gxderror.h \
	$(GLIB_INCLUDE_PATH)gxd_ver.h \
	$(GLIB_INCLUDE_PATH)gxint32.h \
	$(GLIB_INCLUDE_PATH)gxdbase.h \
	$(GLIB_INCLUDE_PATH)gxcrc32.h \
	$(GLIB_INCLUDE_PATH)gxuint32.h

PSCRIPT_DEP = $(GLIB_INCLUDE_PATH)pscript.h

SCOMSERV_DEP = $(GLIB_INCLUDE_PATH)gxscomm.h \
	$(GLIB_INCLUDE_PATH)scomserv.h \
	$(GLIB_INCLUDE_PATH)gxheader.h \
	$(GLIB_INCLUDE_PATH)gxdtypes.h \
	$(GLIB_INCLUDE_PATH)gxd_ver.h \
	$(GLIB_INCLUDE_PATH)gxint32.h \
	$(GLIB_INCLUDE_PATH)gxuint32.h

SREG101_DEP = $(GLIB_INCLUDE_PATH)sreg101.h

STRUTIL_DEP = $(GLIB_INCLUDE_PATH)strutil.h

SYSTIME_DEP = $(GLIB_INCLUDE_PATH)ustring.h \
	$(GLIB_INCLUDE_PATH)systime.h

TERMINAL_DEP = $(GLIB_INCLUDE_PATH)terminal.h

THELPERS_DEP = $(GLIB_INCLUDE_PATH)thrtypes.h \
	$(GLIB_INCLUDE_PATH)thelpers.h

THRAPIW_DEP = $(GLIB_INCLUDE_PATH)thrtypes.h \
	$(GLIB_INCLUDE_PATH)thrapiw.h \
	$(GLIB_INCLUDE_PATH)gthreadt.h \
	$(GLIB_INCLUDE_PATH)gxthread.h \
	$(GLIB_INCLUDE_PATH)thrpool.h \
	$(GLIB_INCLUDE_PATH)gxmutex.h \
	$(GLIB_INCLUDE_PATH)gxcond.h \
	$(GLIB_INCLUDE_PATH)thelpers.h

THRPOOL_DEP = $(GLIB_INCLUDE_PATH)thrtypes.h \
	$(GLIB_INCLUDE_PATH)thrpool.h \
	$(GLIB_INCLUDE_PATH)gthreadt.h

USTRING_DEP = $(GLIB_INCLUDE_PATH)ustring.h

WSERROR_DEP = $(GLIB_INCLUDE_PATH)gxsocket.h \
	$(GLIB_INCLUDE_PATH)wserror.h
# ===============================================================

# Compile the object files and build the DLL, .exp, .pch, .lib files
# ===============================================================
all:	"./$(OUTDIR)\$(PROJECT)$(SHAREDLIB_EXT)"

# DLL entry point targets
$(OUTDIR)\stdafx$(OBJ_EXT):	$(GLIB_SRC_PATH)stdafx.cpp $(STDAFX_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)stdafx.cpp

$(OUTDIR)\gxdlcode$(OBJ_EXT):	$(GLIB_SRC_PATH)gxdlcode.cpp $(GXDLCODE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxdlcode.cpp

# GX code targets
$(OUTDIR)\asprint$(OBJ_EXT):	$(GLIB_SRC_PATH)asprint.cpp $(ASPRINT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)asprint.cpp

$(OUTDIR)\bstreei$(OBJ_EXT):	$(GLIB_SRC_PATH)bstreei.cpp $(GXSTREEI_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)bstreei.cpp

$(OUTDIR)\btnode$(OBJ_EXT):	$(GLIB_SRC_PATH)btnode.cpp $(BTNODE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)btnode.cpp

$(OUTDIR)\btstack$(OBJ_EXT):	$(GLIB_SRC_PATH)btstack.cpp $(BTSTACK_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)btstack.cpp

$(OUTDIR)\cdate$(OBJ_EXT):	$(GLIB_SRC_PATH)cdate.cpp $(CDATE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)cdate.cpp

$(OUTDIR)\dbasekey$(OBJ_EXT):	$(GLIB_SRC_PATH)dbasekey.cpp $(DBASEKEY_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)dbasekey.cpp

$(OUTDIR)\devcache$(OBJ_EXT):	$(GLIB_SRC_PATH)devcache.cpp $(DEVCACHE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)devcache.cpp

$(OUTDIR)\dfileb$(OBJ_EXT):	$(GLIB_SRC_PATH)dfileb.cpp $(DFILEB_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)dfileb.cpp

$(OUTDIR)\eds101$(OBJ_EXT):	$(GLIB_SRC_PATH)eds101.cpp $(EDS101_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)eds101.cpp

$(OUTDIR)\eds201$(OBJ_EXT):	$(GLIB_SRC_PATH)eds201.cpp $(EDS201_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)eds201.cpp

$(OUTDIR)\edscfg$(OBJ_EXT):	$(GLIB_SRC_PATH)edscfg.cpp $(EDSCFG_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)edscfg.cpp

$(OUTDIR)\ehandler$(OBJ_EXT):	$(GLIB_SRC_PATH)ehandler.cpp $(EHANDLER_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)ehandler.cpp

$(OUTDIR)\fstring$(OBJ_EXT):	$(GLIB_SRC_PATH)fstring.cpp $(FSTRING_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)fstring.cpp

$(OUTDIR)\futils$(OBJ_EXT):	$(GLIB_SRC_PATH)futils.cpp $(FUTILS_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)futils.cpp

$(OUTDIR)\gpersist$(OBJ_EXT):	$(GLIB_SRC_PATH)gpersist.cpp $(GPERSIST_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gpersist.cpp

$(OUTDIR)\gthreadt$(OBJ_EXT):	$(GLIB_SRC_PATH)gthreadt.cpp $(GTHREADT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gthreadt.cpp

$(OUTDIR)\gxbtree$(OBJ_EXT):	$(GLIB_SRC_PATH)gxbtree.cpp $(GXTREE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxbtree.cpp

$(OUTDIR)\gxcond$(OBJ_EXT):	$(GLIB_SRC_PATH)gxcond.cpp $(GXCOND_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxcond.cpp

$(OUTDIR)\gxconfig$(OBJ_EXT):	$(GLIB_SRC_PATH)gxconfig.cpp $(GXCONFIG_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxconfig.cpp

$(OUTDIR)\gxcrc32$(OBJ_EXT):	$(GLIB_SRC_PATH)gxcrc32.cpp $(GXCRC32_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxcrc32.cpp

$(OUTDIR)\gxdatagm$(OBJ_EXT):	$(GLIB_SRC_PATH)gxdatagm.cpp $(GXDATAGM_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxdatagm.cpp

$(OUTDIR)\gxdbase$(OBJ_EXT):    $(GLIB_SRC_PATH)gxdbase.cpp $(GXDBASE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxdbase.cpp

$(OUTDIR)\gxderror$(OBJ_EXT):	$(GLIB_SRC_PATH)gxderror.cpp $(GXDERROR_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxderror.cpp

$(OUTDIR)\gxdfp64$(OBJ_EXT):    $(GLIB_SRC_PATH)gxdfp64.cpp $(GXDFP64_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxdfp64.cpp

$(OUTDIR)\gxdfptr$(OBJ_EXT):    $(GLIB_SRC_PATH)gxdfptr.cpp $(GXDFPTR_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxdfptr.cpp

$(OUTDIR)\gxdstats$(OBJ_EXT):	$(GLIB_SRC_PATH)gxdstats.cpp $(GXDSTATS_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxdstats.cpp

$(OUTDIR)\gxfloat$(OBJ_EXT):	$(GLIB_SRC_PATH)gxfloat.cpp $(GXFLOAT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxfloat.cpp

$(OUTDIR)\gxint16$(OBJ_EXT):	$(GLIB_SRC_PATH)gxint16.cpp $(GXINT16_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxint16.cpp

$(OUTDIR)\gxint32$(OBJ_EXT):	$(GLIB_SRC_PATH)gxint32.cpp $(GXINT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxint32.cpp

$(OUTDIR)\gxint64$(OBJ_EXT):	$(GLIB_SRC_PATH)gxint64.cpp $(GXINT64_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxint64.cpp

$(OUTDIR)\gxip32$(OBJ_EXT):	$(GLIB_SRC_PATH)gxip32.cpp $(GXIP32_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxip32.cpp

$(OUTDIR)\gxlistb$(OBJ_EXT):	$(GLIB_SRC_PATH)gxlistb.cpp $(GXLISTB_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxlistb.cpp

$(OUTDIR)\gxmac48$(OBJ_EXT):	$(GLIB_SRC_PATH)gxmac48.cpp $(GXMAC48_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxmac48.cpp

$(OUTDIR)\gxmutex$(OBJ_EXT):	$(GLIB_SRC_PATH)gxmutex.cpp $(GXMUTEX_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxmutex.cpp

$(OUTDIR)\gxscomm$(OBJ_EXT):	$(GLIB_SRC_PATH)gxscomm.cpp $(GXSCOMM_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxscomm.cpp

$(OUTDIR)\gxsema$(OBJ_EXT):	$(GLIB_SRC_PATH)gxsema.cpp $(GXSEMA_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxsema.cpp

$(OUTDIR)\gxsftp$(OBJ_EXT):	$(GLIB_SRC_PATH)gxsftp.cpp $(GXSFTP_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxsftp.cpp

$(OUTDIR)\gxshtml$(OBJ_EXT):	$(GLIB_SRC_PATH)gxshtml.cpp $(GXSHTML_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxshtml.cpp

$(OUTDIR)\gxshttp$(OBJ_EXT):	$(GLIB_SRC_PATH)gxshttp.cpp $(GXSHTTP_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxshttp.cpp

$(OUTDIR)\gxshttpc$(OBJ_EXT):	$(GLIB_SRC_PATH)gxshttpc.cpp $(GXSHTTPC_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxshttpc.cpp

$(OUTDIR)\gxsmtp$(OBJ_EXT):	$(GLIB_SRC_PATH)gxsmtp.cpp $(GXSMTP_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxsmtp.cpp

$(OUTDIR)\gxsocket$(OBJ_EXT):	$(GLIB_SRC_PATH)gxsocket.cpp $(GXSOCKET_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxsocket.cpp

$(OUTDIR)\gxsping$(OBJ_EXT):	$(GLIB_SRC_PATH)gxsping.cpp $(GXSPING_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxsping.cpp

$(OUTDIR)\gxspop3$(OBJ_EXT):	$(GLIB_SRC_PATH)gxspop3.cpp $(GXSPOP3_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxspop3.cpp

$(OUTDIR)\gxstream$(OBJ_EXT):	$(GLIB_SRC_PATH)gxstream.cpp $(GXSTREAM_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxstream.cpp

$(OUTDIR)\gxsurl$(OBJ_EXT):	$(GLIB_SRC_PATH)gxsurl.cpp $(GXSURL_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxsurl.cpp

$(OUTDIR)\gxsutils$(OBJ_EXT):	$(GLIB_SRC_PATH)gxsutils.cpp $(GXSUTILS_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxsutils.cpp

$(OUTDIR)\gxs_b64$(OBJ_EXT):	$(GLIB_SRC_PATH)gxs_b64.cpp $(GXS_B64_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxs_b64.cpp

$(OUTDIR)\gxtelnet$(OBJ_EXT):	$(GLIB_SRC_PATH)gxtelnet.cpp $(GXTELNET_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxtelnet.cpp

$(OUTDIR)\gxthread$(OBJ_EXT):	$(GLIB_SRC_PATH)gxthread.cpp $(GXTHREAD_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxthread.cpp

$(OUTDIR)\gxuint16$(OBJ_EXT):	$(GLIB_SRC_PATH)gxuint16.cpp $(GXUINT16_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxuint16.cpp

$(OUTDIR)\gxuint32$(OBJ_EXT):	$(GLIB_SRC_PATH)gxuint32.cpp $(GXUINT32_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxuint32.cpp

$(OUTDIR)\gxuint64$(OBJ_EXT):	$(GLIB_SRC_PATH)gxuint64.cpp $(GXUINT64_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)gxuint64.cpp

$(OUTDIR)\htmldrv$(OBJ_EXT):	$(GLIB_SRC_PATH)htmldrv.cpp $(HTMLDRV_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)htmldrv.cpp

$(OUTDIR)\httpgrab$(OBJ_EXT):	$(GLIB_SRC_PATH)httpgrab.cpp $(HTTPGRAB_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)httpgrab.cpp

$(OUTDIR)\leaktest$(OBJ_EXT):	$(GLIB_SRC_PATH)leaktest.cpp $(LEAKTEST_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)leaktest.cpp

$(OUTDIR)\logfile$(OBJ_EXT):	$(GLIB_SRC_PATH)logfile.cpp $(LOGFILE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)logfile.cpp

$(OUTDIR)\memblock$(OBJ_EXT):	$(GLIB_SRC_PATH)memblock.cpp $(MEMBLOCK_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)memblock.cpp

$(OUTDIR)\membuf$(OBJ_EXT):	$(GLIB_SRC_PATH)membuf.cpp $(MEMBUF_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)membuf.cpp

$(OUTDIR)\ostrbase$(OBJ_EXT):	$(GLIB_SRC_PATH)ostrbase.cpp $(OSTRBASE_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)ostrbase.cpp

$(OUTDIR)\pod$(OBJ_EXT):	$(GLIB_SRC_PATH)pod.cpp $(POD_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)pod.cpp

$(OUTDIR)\pscript$(OBJ_EXT):	$(GLIB_SRC_PATH)pscript.cpp $(PSCRIPT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)pscript.cpp

$(OUTDIR)\scomserv$(OBJ_EXT):	$(GLIB_SRC_PATH)scomserv.cpp $(SCOMSERV_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)scomserv.cpp

$(OUTDIR)\sreg101$(OBJ_EXT):	$(GLIB_SRC_PATH)sreg101.cpp $(SREG101_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)sreg101.cpp

$(OUTDIR)\strutil$(OBJ_EXT):	$(GLIB_SRC_PATH)strutil.cpp $(STRUTIL_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)strutil.cpp

$(OUTDIR)\systime$(OBJ_EXT):	$(GLIB_SRC_PATH)systime.cpp $(SYSTIME_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)systime.cpp

$(OUTDIR)\terminal$(OBJ_EXT):	$(GLIB_SRC_PATH)terminal.cpp $(TERMINAL_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)terminal.cpp

$(OUTDIR)\thelpers$(OBJ_EXT):	$(GLIB_SRC_PATH)thelpers.cpp $(THELPERS_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)thelpers.cpp

$(OUTDIR)\thrapiw$(OBJ_EXT):	$(GLIB_SRC_PATH)thrapiw.cpp $(THRAPIW_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)thrapiw.cpp

$(OUTDIR)\thrpool$(OBJ_EXT):	$(GLIB_SRC_PATH)thrpool.cpp $(THRPOOL_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)thrpool.cpp

$(OUTDIR)\ustring$(OBJ_EXT):	$(GLIB_SRC_PATH)ustring.cpp $(USTRING_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)ustring.cpp

$(OUTDIR)\wserror$(OBJ_EXT):	$(GLIB_SRC_PATH)wserror.cpp $(WSERROR_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(GLIB_SRC_PATH)wserror.cpp

# DLL entry point objects
GLIB_DLL_OBJECTS = $(OUTDIR)\stdafx$(OBJ_EXT) \
	$(OUTDIR)\gxdlcode$(OBJ_EXT)

# Non-messaging gxcode objects
GLIB_OBJECTS = $(OUTDIR)\asprint$(OBJ_EXT) \
	$(OUTDIR)\bstreei$(OBJ_EXT) \
	$(OUTDIR)\btnode$(OBJ_EXT) \
	$(OUTDIR)\btstack$(OBJ_EXT) \
	$(OUTDIR)\cdate$(OBJ_EXT) \
	$(OUTDIR)\dbasekey$(OBJ_EXT) \
	$(OUTDIR)\devcache$(OBJ_EXT) \
	$(OUTDIR)\dfileb$(OBJ_EXT) \
	$(OUTDIR)\eds101$(OBJ_EXT) \
	$(OUTDIR)\eds201$(OBJ_EXT) \
	$(OUTDIR)\edscfg$(OBJ_EXT) \
	$(OUTDIR)\fstring$(OBJ_EXT) \
	$(OUTDIR)\futils$(OBJ_EXT) \
	$(OUTDIR)\gpersist$(OBJ_EXT) \
	$(OUTDIR)\gthreadt$(OBJ_EXT) \
	$(OUTDIR)\gxbtree$(OBJ_EXT) \
	$(OUTDIR)\gxcond$(OBJ_EXT) \
	$(OUTDIR)\gxconfig$(OBJ_EXT) \
	$(OUTDIR)\gxcrc32$(OBJ_EXT) \
	$(OUTDIR)\gxdatagm$(OBJ_EXT) \
	$(OUTDIR)\gxdbase$(OBJ_EXT) \
	$(OUTDIR)\gxderror$(OBJ_EXT) \
	$(OUTDIR)\gxdfp64$(OBJ_EXT) \
	$(OUTDIR)\gxdfptr$(OBJ_EXT) \
	$(OUTDIR)\gxfloat$(OBJ_EXT) \
	$(OUTDIR)\gxint16$(OBJ_EXT) \
	$(OUTDIR)\gxint32$(OBJ_EXT) \
	$(OUTDIR)\gxint64$(OBJ_EXT) \
	$(OUTDIR)\gxip32$(OBJ_EXT) \
	$(OUTDIR)\gxlistb$(OBJ_EXT) \
	$(OUTDIR)\gxmac48$(OBJ_EXT) \
	$(OUTDIR)\gxmutex$(OBJ_EXT) \
	$(OUTDIR)\gxscomm$(OBJ_EXT) \
	$(OUTDIR)\gxsema$(OBJ_EXT) \
	$(OUTDIR)\gxsftp$(OBJ_EXT) \
	$(OUTDIR)\gxshtml$(OBJ_EXT) \
	$(OUTDIR)\gxshttp$(OBJ_EXT) \
	$(OUTDIR)\gxshttpc$(OBJ_EXT) \
	$(OUTDIR)\gxsmtp$(OBJ_EXT) \
	$(OUTDIR)\gxsocket$(OBJ_EXT) \
	$(OUTDIR)\gxsping$(OBJ_EXT) \
	$(OUTDIR)\gxspop3$(OBJ_EXT) \
	$(OUTDIR)\gxstream$(OBJ_EXT) \
	$(OUTDIR)\gxsurl$(OBJ_EXT) \
	$(OUTDIR)\gxsutils$(OBJ_EXT) \
	$(OUTDIR)\gxs_b64$(OBJ_EXT) \
	$(OUTDIR)\gxtelnet$(OBJ_EXT) \
	$(OUTDIR)\gxthread$(OBJ_EXT) \
	$(OUTDIR)\gxuint16$(OBJ_EXT) \
	$(OUTDIR)\gxuint32$(OBJ_EXT) \
	$(OUTDIR)\gxuint64$(OBJ_EXT) \
	$(OUTDIR)\htmldrv$(OBJ_EXT) \
	$(OUTDIR)\logfile$(OBJ_EXT) \
	$(OUTDIR)\memblock$(OBJ_EXT) \
	$(OUTDIR)\membuf$(OBJ_EXT) \
	$(OUTDIR)\ostrbase$(OBJ_EXT) \
	$(OUTDIR)\pod$(OBJ_EXT) \
	$(OUTDIR)\pscript$(OBJ_EXT) \
	$(OUTDIR)\scomserv$(OBJ_EXT) \
	$(OUTDIR)\sreg101$(OBJ_EXT) \
	$(OUTDIR)\strutil$(OBJ_EXT) \
	$(OUTDIR)\systime$(OBJ_EXT) \
	$(OUTDIR)\thelpers$(OBJ_EXT) \
	$(OUTDIR)\thrapiw$(OBJ_EXT) \
	$(OUTDIR)\thrpool$(OBJ_EXT) \
	$(OUTDIR)\ustring$(OBJ_EXT) \
	$(OUTDIR)\wserror$(OBJ_EXT)

# Optional debug objects
# NOTE: The leak test functions requires the /D__MSVC_DEBUG__ compiler
# flag and the /MDd or /MTd compiler flag. 
GLIB_DEBUG_OBJECTS = # $(OUTDIR)\leaktest$(OBJ_EXT)

# Term I/O objects
GLIB_TERM_OBJECTS = $(OUTDIR)\terminal$(OBJ_EXT)

# Console/GUI messaging gxcode objects
GLIB_MSG_OBJECTS = $(OUTDIR)\ehandler$(OBJ_EXT) \
	$(OUTDIR)\gxdstats$(OBJ_EXT) \
	$(OUTDIR)\httpgrab$(OBJ_EXT)

# Add all object files here
OBJECTS = $(GLIB_DLL_OBJECTS) $(GLIB_OBJECTS) $(GLIB_TERM_OBJECTS) \
$(GLIB_MSG_OBJECTS) $(GLIB_DEBUG_OBJECTS)

"./$(OUTDIR)\$(PROJECT)$(SHAREDLIB_EXT)" :  $(OBJECTS)
	$(LINKER) $(LINKER_FLAGS) $(OBJECTS) $(LINK_LIBRARIES)
# ===============================================================

# Remove object files
# ===============================================================
clean:
	@echo Removing all .SBR files from working directory...
	if exist $(OUTDIR)\*.sbr del $(OUTDIR)\*.sbr  

	@echo Removing all .VCW files from working directory...
	if exist $(OUTDIR)\*.vcw del $(OUTDIR)\*.vcw 

	@echo Removing all .WSP files from working directory...
	if exist $(OUTDIR)\*.wsp del $(OUTDIR)\*.wsp 

	@echo Removing all .BSC files from working directory...
	if exist $(OUTDIR)\*.bsc del $(OUTDIR)\*.bsc 

	@echo Removing all .SBT files from working directory...
	if exist $(OUTDIR)\*.sbt del $(OUTDIR)\*.sbt 

	@echo Removing all .ILK files from working directory...
	if exist $(OUTDIR)\*.ilk del $(OUTDIR)\*.ilk 

	@echo Removing all .IDB files from working directory...
	if exist $(OUTDIR)\*.idb del $(OUTDIR)\*.idb 

	@echo Removing all .MDP files from working directory...
	if exist $(OUTDIR)\*.mdp del $(OUTDIR)\*.mdp 

	@echo Removing all .NCB files from working directory...
	if exist $(OUTDIR)\*.ncb del $(OUTDIR)\*.ncb 

	@echo Removing all .OBJ files from working directory...
	if exist $(OUTDIR)\*.obj del $(OUTDIR)\*.obj 
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################


