# Include file used for all project makefiles

# Pre-defined include and source code paths for this project
INCLUDE_PATH = $(PROJECT_INCLUDE_PATH)$(PATHSEP)
SRC_PATH = $(PROJECT_SRC_PATH)$(PATHSEP)

# Build dependency rules
# ==============================================================
USTRING_DEP = $(INCLUDE_PATH)ustring.h

GXS_B64_DEP = $(INCLUDE_PATH)ustring.h $(INCLUDE_PATH)gxstring.h \
	$(INCLUDE_PATH)gxs_b64.h

PROJECT_DEP = $(INCLUDE_PATH)ustring.h $(INCLUDE_PATH)gxstring.h \
	$(INCLUDE_PATH)gxs_b64.h
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT)$(EXE_EXT)

ustring$(OBJ_EXT):	$(SRC_PATH)ustring.cpp $(USTRING_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(SRC_PATH)ustring.cpp

gxs_b64$(OBJ_EXT):	../../src/gxs_b64.cpp $(GXS_B64_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(SRC_PATH)gxs_b64.cpp

$(PROJECT)$(OBJ_EXT):	$(PROJECT).cpp $(PROJECT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(PROJECT).cpp

leaktest$(OBJ_EXT):    $(SRC_PATH)leaktest.cpp $(LEAKTEST_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(SRC_PATH)leaktest.cpp

# Make the executable
OBJECTS = $(PROJECT)$(OBJ_EXT) leaktest$(OBJ_EXT)\
	ustring$(OBJ_EXT) gxs_b64$(OBJ_EXT)
# ===============================================================
