# Include file used for all project makefiles

# Pre-defined include and source code paths for this project
INCLUDE_PATH = ../../include/
SRC_PATH = ../../src/

# Build dependency rules
# ==============================================================
GXSOCKET_DEP = $(INCLUDE_PATH)gxsocket.h $(INCLUDE_PATH)gxstypes.h

GXSUTILS_DEP = $(INCLUDE_PATH)gxsocket.h $(INCLUDE_PATH)gxstypes.h \
	$(INCLUDE_PATH)gxsutils.h

GXSPING_DEP = $(INCLUDE_PATH)gxsocket.h $(INCLUDE_PATH)gxstypes.h \
	$(INCLUDE_PATH)gxsutils.h $(INCLUDE_PATH)gxsping.h

PROJECT_DEP = $(INCLUDE_PATH)gxsocket.h $(INCLUDE_PATH)gxstypes.h \
	$(INCLUDE_PATH)gxsping.h
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT)$(EXE_EXT)

gxsocket$(OBJ_EXT):	$(SRC_PATH)gxsocket.cpp $(GXSOCKET_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(SRC_PATH)gxsocket.cpp

gxsping$(OBJ_EXT):	$(SRC_PATH)gxsping.cpp $(GXSPING_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(SRC_PATH)gxsping.cpp

gxsutils$(OBJ_EXT):	$(SRC_PATH)gxsutils.cpp $(GXSUTILS_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(SRC_PATH)gxsutils.cpp

$(PROJECT)$(OBJ_EXT):	$(PROJECT).cpp $(PROJECT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(PROJECT).cpp

leaktest$(OBJ_EXT):    $(SRC_PATH)leaktest.cpp $(LEAKTEST_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(SRC_PATH)leaktest.cpp

# Make the executable
OBJECTS = gxsocket$(OBJ_EXT) gxsping$(OBJ_EXT) gxsutils$(OBJ_EXT) \
	$(PROJECT)$(OBJ_EXT) leaktest$(OBJ_EXT)
# ===============================================================
