#######################
#### Start of File ####
#######################
# --------------------------------------------------------------- 
# Makefile Contents: Makefile for the Solaris 11 gxcode library
# C/C++ Compiler Used: Sun WorkShop C++ 5.0 (4.2 compatibility mode)
# Produced By: glNET Software
# File Creation Date: 05/25/2001
# Date Last Modified: 07/27/2001
# --------------------------------------------------------------- 
# Setup my path to the gxcode library
GCODE_LIB_DIR = ..

include solaris.env

# Define a name for the static library
PROJECT = libgxcode
# PROJECT = libgxcode64 # 64-bit static library

# Build dependency rules
# ===============================================================
include ../env/glibdeps.mak
# ===============================================================

# Compile the object files and build the library
# ===============================================================
all:	$(PROJECT)$(LIB_EXT)

include ../env/glibobjs.mak

# Non-messaging gxcode objects
GLIB_OBJECTS = asprint$(OBJ_EXT) bstreei$(OBJ_EXT) btnode$(OBJ_EXT) \
	btstack$(OBJ_EXT) cdate$(OBJ_EXT) dbasekey$(OBJ_EXT) \
	devcache$(OBJ_EXT) dfileb$(OBJ_EXT) eds101$(OBJ_EXT) \
	eds201$(OBJ_EXT) edscfg$(OBJ_EXT) \
	fstring$(OBJ_EXT) futils$(OBJ_EXT) gpersist$(OBJ_EXT) \
	gthreadt$(OBJ_EXT) gxbtree$(OBJ_EXT) gxcond$(OBJ_EXT) \
	gxconfig$(OBJ_EXT) gxcrc32$(OBJ_EXT) gxdatagm$(OBJ_EXT) \
	gxdbase$(OBJ_EXT) gxderror$(OBJ_EXT) gxdfp64$(OBJ_EXT) \
	gxdfptr$(OBJ_EXT) gxfloat$(OBJ_EXT) \
	gxint16$(OBJ_EXT) gxint32$(OBJ_EXT) gxint64$(OBJ_EXT) \
	gxip32$(OBJ_EXT) gxlistb$(OBJ_EXT) gxmac48$(OBJ_EXT) \
	gxmutex$(OBJ_EXT) gxscomm$(OBJ_EXT) gxsema$(OBJ_EXT) \
	gxsftp$(OBJ_EXT) gxshtml$(OBJ_EXT) gxshttp$(OBJ_EXT) \
	gxshttpc$(OBJ_EXT) gxsmtp$(OBJ_EXT) gxsocket$(OBJ_EXT) \
	gxsping$(OBJ_EXT) gxspop3$(OBJ_EXT) gxstream$(OBJ_EXT) \
	gxsurl$(OBJ_EXT) gxsutils$(OBJ_EXT) gxs_b64$(OBJ_EXT) \
	gxtelnet$(OBJ_EXT) gxthread$(OBJ_EXT) gxuint16$(OBJ_EXT) \
	gxuint32$(OBJ_EXT) gxuint64$(OBJ_EXT) htmldrv$(OBJ_EXT) \
	logfile$(OBJ_EXT) \
	memblock$(OBJ_EXT) membuf$(OBJ_EXT) ostrbase$(OBJ_EXT) \
	pod$(OBJ_EXT) pscript$(OBJ_EXT) scomserv$(OBJ_EXT) \
	sreg101$(OBJ_EXT) strutil$(OBJ_EXT) systime$(OBJ_EXT) \
	thelpers$(OBJ_EXT) thrapiw$(OBJ_EXT) \
	thrpool$(OBJ_EXT) ustring$(OBJ_EXT) wserror$(OBJ_EXT)

# Optional debug objects
# GLIB_DEBUG_OBJECTS = leaktest$(OBJ_EXT)

# Term I/O objects
GLIB_TERM_OBJECTS = terminal$(OBJ_EXT)

# Console/GUI messaging gxcode objects
GLIB_MSG_OBJECTS = ehandler$(OBJ_EXT) gxdstats$(OBJ_EXT) httpgrab$(OBJ_EXT)

# Add additional object files here
OBJECTS = $(GLIB_OBJECTS) $(GLIB_TERM_OBJECTS) $(GLIB_MSG_OBJECTS) \
$(GLIB_DEBUG_OBJECTS)

# Command used to build the static library
$(PROJECT)$(LIB_EXT):	$(OBJECTS)
	$(LIBUTIL) $(LIBUTIL_FLAGS) -o ./$@ $(OBJECTS)
# ===============================================================

# Remove object files 
# ===============================================================
clean:
	echo Removing all OBJECT files from working directory...
	rm -f *.o 
# --------------------------------------------------------------- 
#####################
#### End of File ####
#####################
