# Include file used for all project makefiles

# Pre-defined include and source code paths for this project
INCLUDE_PATH = $(PROJECT_INCLUDE_PATH)$(PATHSEP)
SRC_PATH = $(PROJECT_SRC_PATH)$(PATHSEP)

# Build dependency rules
# ===============================================================
USTRING_DEP = $(INCLUDE_PATH)ustring.h

FUTILS_DEP = $(INCLUDE_PATH)futils.h

STRUTIL_DEP = $(INCLUDE_PATH)strutil.h

PROJECT_DEP = $(INCLUDE_PATH)ustring.h \
	$(INCLUDE_PATH)gxlist.h $(INCLUDE_PATH)futils.h \
	$(INCLUDE_PATH)strutil.h
# ===============================================================

# Compile the files and build the executable
# ===============================================================
all:	$(PROJECT)$(EXE_EXT)

ustring$(OBJ_EXT):    $(SRC_PATH)ustring.cpp $(USTRING_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(SRC_PATH)ustring.cpp

futils$(OBJ_EXT):    $(SRC_PATH)futils.cpp $(FUTILS_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(SRC_PATH)futils.cpp

strutil$(OBJ_EXT):    $(SRC_PATH)strutil.cpp $(STRUTIL_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(SRC_PATH)strutil.cpp

$(PROJECT)$(OBJ_EXT):	$(PROJECT).cpp $(PROJECT_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) $(PROJECT).cpp

leaktest$(OBJ_EXT):    $(SRC_PATH)leaktest.cpp $(LEAKTEST_DEP)
	$(CPP) $(COMPILE_ONLY) $(COMPILE_FLAGS) \
	$(SRC_PATH)leaktest.cpp

# Make the executable
OBJECTS = $(PROJECT)$(OBJ_EXT) leaktest$(OBJ_EXT) \
	ustring$(OBJ_EXT) futils$(OBJ_EXT) strutil$(OBJ_EXT)
# ===============================================================
