
<!--$Id: bkd4cpp.xsl,v 1.6 2001/10/30 14:49:34 csimon Exp $-->
<!-- This file is used to transform data generated by 'getbkdapi' (a tool from the Epeios project) in a C++ header file using XSLT. This header file contains then the API to access to the backend to which 'getbkdapi' was connected. -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="text"/>
  <xsl:template match="/" xml:space="preserve">/* DON'T MODIFY */
/* This file was generated using <xsl:value-of select="/API/Misc/Generator/Name"/> V<xsl:value-of select="/API/Misc/Generator/Version"/>,
and a XSL file ($RCSfile: bkd4cpp.xsl,v $ $Revision: 1.6 $ $Date: 2001/10/30 14:49:34 $ $Author: csimon $) */
// $Id: bkd4cpp.xsl,v 1.6 2001/10/30 14:49:34 csimon Exp $  (CVS feature).

#ifndef <xsl:value-of select="/API/Misc/Backend/Name"/>__INC
#define <xsl:value-of select="/API/Misc/Backend/Name"/>__INC
<xsl:apply-templates select="API"/>
#endif //#ifndef <xsl:value-of select="/API/Misc/Backend/Name"/>__INC

</xsl:template>
  <xsl:template match="API" xml:space="preserve">
#include "bkdacc.h"

<xsl:apply-templates select="Types"/></xsl:template>
  <xsl:template match="Types">
    <xsl:apply-templates select="Type" mode="common"/>
    <xsl:apply-templates select="Type" mode="object"/>
  </xsl:template>
  <xsl:template match="Type" mode="common" xml:space="preserve">
    <xsl:choose>
      <xsl:when test="@Object='Master'">class statics___</xsl:when>
      <xsl:otherwise>class <xsl:value-of select="Prefix@Default"/>_<xsl:value-of select="Name@Underscored"/>_common__</xsl:otherwise>
    </xsl:choose>
{
private:
	<xsl:choose>
      <xsl:when test="@Object='Master'">bkdacc::object__</xsl:when>
      <xsl:otherwise>bkdacc::id16__</xsl:otherwise>
    </xsl:choose> ID_;
public:
	bkdacc::backend_access___ *Backend;
	bkdacc::command__ Commands[<xsl:value-of select="Commands/@Amount"/>];
	void Init( bkdacc::backend_access___ &amp;Backend )
	{
		bkdacc::commands_details CommandsDetails;
		bkdacc::command_detail CommandDetail;
		bkdacc::ids16 Commands;
		bkdacc::id8__ Parameters[] = {
<xsl:apply-templates select="Commands" mode="data"/>		};
		this->Backend = &amp;Backend;
		ID_ = <xsl:choose>
      <xsl:when test="@Object='Master'">BKDACC_MASTER_OBJECT;</xsl:when>
      <xsl:otherwise>this->Backend->GetType( str::string( "<xsl:value-of select="Name"/>" ) );</xsl:otherwise>
    </xsl:choose>
		CommandsDetails.Init();

<xsl:apply-templates select="Commands" mode="affectation"/>		Commands.Init();

		this->Backend->GetCommands( <xsl:choose>
      <xsl:when test="@Object='Master'">BKDACC_MASTER_TYPE</xsl:when>
      <xsl:otherwise>ID_</xsl:otherwise>
    </xsl:choose>, CommandsDetails, Commands );
		Commands.Read( 0, <xsl:value-of select="Commands/@Amount"/>, this->Commands );
	}
<xsl:choose>
      <xsl:when test="@Object='Master'">
        <xsl:apply-templates select="Commands" mode="function"/>
      </xsl:when>
      <xsl:otherwise>	bkdacc::object__ GetNewObject( void )
	{
		return Backend->GetNewObject( ID_ );
	}
</xsl:otherwise>
    </xsl:choose>};

</xsl:template>
  <xsl:template match="Type[@Object='Master']" mode="object"/>
  <xsl:template match="Type" mode="object" xml:space="preserve">class <xsl:value-of select="Prefix@Default"/>_<xsl:value-of select="Name@Underscored"/>
{
private:
	bkdacc::object__ ID_;
	<xsl:value-of select="Prefix@Default"/>_<xsl:value-of select="Name@Underscored"/>_common__ *Common_;
public:
	bkdacc::object__ ID( void )
	{
		return ID_;
	}
	void Init( <xsl:value-of select="Prefix@Default"/>_<xsl:value-of select="Name@Underscored"/>_common__ &amp;Common )
	{
		Common_ = &amp;Common;

		ID_ = Common_->GetNewObject();
	}
<xsl:apply-templates select="Commands" mode="function">
      <xsl:with-param name="Base">Common_-></xsl:with-param>
    </xsl:apply-templates>};

</xsl:template>
  <xsl:template match="Commands" mode="data">
    <xsl:apply-templates select="Command" mode="data"/>
  </xsl:template>
  <xsl:template match="Command" mode="data">
    <xsl:apply-templates select="Parameters" mode="data"/>
  </xsl:template>
  <xsl:template match="Parameters" mode="data">
    <xsl:text disable-output-escaping="yes">				</xsl:text>
    <xsl:apply-templates select="In" mode="data"/>0,<xsl:apply-templates select="Out" mode="data"/><xsl:text disable-output-escaping="yes">
  </xsl:text></xsl:template>
  <xsl:template match="Parameter" mode="data">
    <xsl:value-of select="ID"/>,</xsl:template>
  <xsl:template match="Commands" mode="function">
    <xsl:param name="Base"/>
    <xsl:apply-templates select="Command" mode="function">
      <xsl:with-param name="Base">
        <xsl:value-of select="$Base"/>
      </xsl:with-param>
    </xsl:apply-templates>
  </xsl:template>
  <xsl:template match="Command" mode="function" xml:space="preserve">
    <xsl:param name="Base"/>	bso::bool__ <xsl:value-of select="Name"/>( <xsl:apply-templates select="Parameters" mode="function"/>	{
		bso::bool__ State;

		<xsl:value-of select="$Base"/>Backend->PushHeader( ID_, <xsl:value-of select="$Base"/>Commands[<xsl:value-of select="position()-1"/>] );
<xsl:apply-templates select="Parameters" mode="instruction">
      <xsl:with-param name="Base">
        <xsl:value-of select="$Base"/>
      </xsl:with-param>
    </xsl:apply-templates></xsl:template>
  <xsl:template match="Parameters" mode="function">
    <xsl:choose xml:space="preserve">
      <xsl:when test="@Amount=1">void )
</xsl:when>
      <xsl:otherwise>
        <xsl:text>
</xsl:text>
        <xsl:apply-templates select="In" mode="function"/>
        <xsl:apply-templates select="Out" mode="function"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="In/Parameter" mode="function" xml:space="preserve">		const bkdacc::<xsl:value-of select="Type"/><xsl:value-of select="Name"/><xsl:choose>
      <xsl:when test="@Type='Static'">__</xsl:when>
      <xsl:when test="@Type='Bunch'">_</xsl:when>
      <xsl:when test="@Type='Container'">_</xsl:when>
    </xsl:choose> &amp;In<xsl:value-of select="@Discriminator"/>    <xsl:choose>
      <xsl:when test="@Position='Last'"> )
</xsl:when>
      <xsl:otherwise>,
</xsl:otherwise>
    </xsl:choose>
</xsl:template>
  <xsl:template match="Out/Parameter" mode="function" xml:space="preserve">		bkdacc::<xsl:value-of select="Name"/><xsl:choose>
      <xsl:when test="@Type='Static'">__</xsl:when>
      <xsl:when test="@Type='Bunch'">_</xsl:when>
      <xsl:when test="@Type='Container'">_</xsl:when>
    </xsl:choose> &amp;Out<xsl:value-of select="@Discriminator"/>    <xsl:choose>
      <xsl:when test="@Position='Last'"> )
</xsl:when>
      <xsl:otherwise>,
</xsl:otherwise>
    </xsl:choose>
</xsl:template>
  <xsl:template match="parameter" mode="function" xml:space="preserve">
    <xsl:choose>
      <xsl:when test="@Position='Last'"> )
</xsl:when>
      <xsl:otherwise>,
</xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="Commands" mode="affectation" xml:space="preserve">
    <xsl:apply-templates select="Command" mode="affectation"/>
    <xsl:text>
</xsl:text>
  </xsl:template>
  <xsl:template match="Command" mode="affectation" xml:space="preserve">		CommandDetail.Init();
		CommandDetail.Name = "<xsl:value-of select="Name"/>";
		CommandDetail.Casts.Add( Parameters + <xsl:value-of select="Parameters/@Position"/>, <xsl:value-of select="Parameters/@Amount"/> );
		CommandsDetails.Add( CommandDetail );

</xsl:template>
  <xsl:template match="Parameters" mode="instruction" xml:space="preserve">
    <xsl:param name="Base"/>
    <xsl:apply-templates select="In" mode="instruction">
      <xsl:with-param name="Base">
        <xsl:value-of select="$Base"/>
      </xsl:with-param>
    </xsl:apply-templates>
		if ( State = <xsl:value-of select="$Base"/>Backend->Send() ) {
<xsl:apply-templates select="Out" mode="instruction">
      <xsl:with-param name="Base">
        <xsl:value-of select="$Base"/>
      </xsl:with-param>
    </xsl:apply-templates>		}

		<xsl:value-of select="$Base"/>Backend->TestCompletion();
		return State;
	}
</xsl:template>
  <xsl:template match="In/Parameter" mode="instruction" xml:space="preserve">
    <xsl:param name="Base"/>
    <xsl:text>		</xsl:text>
    <xsl:value-of select="$Base"/>Backend->Push<xsl:value-of select="translate(substring(Name,1,1),'obics','OBICS')"/><xsl:value-of select="substring(Name,2)"/>( In<xsl:value-of select="@Discriminator"/> );
</xsl:template>
  <xsl:template match="Out/Parameter" mode="instruction" xml:space="preserve">    <xsl:param name="Base"/>
<xsl:text>			</xsl:text><xsl:value-of select="$Base"/>Backend->Pop<xsl:value-of select="translate(substring(Name,1,1),'obics','OBICS')"/><xsl:value-of select="substring(Name,2)"/>( Out<xsl:value-of select="@Discriminator"/> );
</xsl:template>
</xsl:stylesheet>