
<!--$Id: bkd4java.xsl,v 1.4 2001/11/08 11:27:14 csimon Exp $-->
<!-- This file is used to transform data generated by 'getbkdapi' (a tool from the Epeios project) in a JAVA files using XSLT. This file contains then the API to access to the backend to which 'getbkdapi' was connected. -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="text"/>
  <xsl:param name="target"/>
  <xsl:template match="/" xml:space="preserve">/* DON'T MODIFY */
/* This file was generated using <xsl:value-of select="/API/Misc/Generator/Name"/> V<xsl:value-of select="/API/Misc/Generator/Version"/>,
and a XSL file ($RCSfile: bkd4java.xsl,v $ $Revision: 1.4 $ $Date: 2001/11/08 11:27:14 $ $Author: csimon $) */
// $Id: bkd4java.xsl,v 1.4 2001/11/08 11:27:14 csimon Exp $  (CVS feature).

// Value of top-level parameter "$target" : ><xsl:value-of select="$target"/><xsl:text>&lt;</xsl:text>

package <xsl:value-of select="/API/Misc/Backend/Name"/>;
<xsl:apply-templates select="API"/>

</xsl:template>
  <xsl:template match="API" xml:space="preserve">
import org.epeios.*;
import org.epeios.backend.types.*;

<xsl:apply-templates select="Types"/></xsl:template>
  <xsl:template match="Types">
    <xsl:apply-templates select="Type" mode="common"/>
    <xsl:apply-templates select="Type" mode="object"/>
  </xsl:template>
  <xsl:template match="Type" mode="common" xml:space="preserve">
 <xsl:if test="concat( Prefix@Upper, Name@Uppercased, 'Core' )=$target or $target=''">
public class <xsl:value-of select="Prefix@Upper"/><xsl:value-of select="Name@Uppercased"/>Core
{
	private short id;
	public org.epeios.Backend backend;
	public short commands[] = new short[<xsl:value-of select="Commands/@Amount"/>];
	public <xsl:value-of select="Prefix@Upper"/><xsl:value-of select="Name@Uppercased"/>Core( org.epeios.Backend backend ) throws EpeiosException
	{
		String names[] = <xsl:apply-templates select="Commands" mode="name"/>
		byte commandsDetails[][] = <xsl:apply-templates select="Commands" mode="detail"/>

		this.backend = backend;
		id = <xsl:choose>
      <xsl:when test="@Object='Master'">-1</xsl:when>
      <xsl:otherwise>this.backend.GetType( "<xsl:value-of select="Name@Underscored"/>" )</xsl:otherwise>
    </xsl:choose>;

		this.backend.GetCommands( id, names, commandsDetails, commands );
	}
<xsl:choose>
      <xsl:when test="@Object='Master'">
        <xsl:apply-templates select="Commands" mode="function"/>
      </xsl:when>
      <xsl:otherwise>	public short GetNewObject() throws EpeiosException
	{
		return backend.GetNewObject( id );
	}
</xsl:otherwise>
    </xsl:choose>};
</xsl:if>
</xsl:template>
  <xsl:template match="Type[@Object='Master']" mode="object"/>
  <xsl:template match="Type" mode="object" xml:space="preserve"> <xsl:if test="concat( Prefix@Upper, Name@Uppercased )=$target or $target=''">
public class <xsl:value-of select="Prefix@Upper"/><xsl:value-of select="Name@Uppercased"/>
{
	private short id;
	<xsl:value-of select="Prefix@Upper"/><xsl:value-of select="Name@Uppercased"/>Core core;
	public short ID()
	{
		return id;
	}
	public <xsl:value-of select="Prefix@Upper"/><xsl:value-of select="Name@Uppercased"/>( <xsl:value-of select="Prefix@Upper"/><xsl:value-of select="Name@Uppercased"/>Core core ) throws EpeiosException
	{
		this.core = core;

		id = core.GetNewObject();
	}
<xsl:apply-templates select="Commands" mode="function">
      <xsl:with-param name="Base">core.</xsl:with-param>
    </xsl:apply-templates>};
</xsl:if>
</xsl:template>
  <xsl:template match="Commands" mode="detail">{<xsl:apply-templates select="Command" mode="detail"/>};</xsl:template>
  <xsl:template match="Command" mode="detail">
    <xsl:text>
			{</xsl:text>
    <xsl:apply-templates select="Parameters" mode="detail"/>},</xsl:template>
  <xsl:template match="Parameters" mode="detail">
    <xsl:apply-templates select="In" mode="data"/>0,<xsl:apply-templates select="Out" mode="data"/></xsl:template>
  <xsl:template match="Parameter" mode="data">
    <xsl:value-of select="ID"/>,</xsl:template>
  <xsl:template match="Commands" mode="function">
    <xsl:param name="Base"/>
    <xsl:apply-templates select="Command" mode="function">
      <xsl:with-param name="Base">
        <xsl:value-of select="$Base"/>
      </xsl:with-param>
    </xsl:apply-templates>
  </xsl:template>
  <xsl:template match="Command" mode="function" xml:space="preserve">
    <xsl:param name="Base"/>	public boolean <xsl:value-of select="Name"/>( <xsl:apply-templates select="Parameters" mode="function"/>
	{
		boolean state;

		<xsl:value-of select="$Base"/>backend.PushHeader( id, <xsl:value-of select="$Base"/>commands[<xsl:value-of select="position()-1"/>] );
<xsl:apply-templates select="Parameters" mode="instruction">
      <xsl:with-param name="Base">
        <xsl:value-of select="$Base"/>
      </xsl:with-param>
    </xsl:apply-templates></xsl:template>
  <xsl:template match="Parameters" mode="function">
    <xsl:if test="not(@Amount=1)" xml:space="preserve">
      <xsl:text>
</xsl:text>
      <xsl:apply-templates select="In" mode="function"/>
      <xsl:apply-templates select="Out" mode="function"/>
    </xsl:if>) throws EpeiosException</xsl:template>
  <xsl:template match="In/Parameter" mode="function" xml:space="preserve">
    <xsl:text>		</xsl:text>
    <xsl:value-of select="Type"/>
    <xsl:apply-templates select="Name" mode="In"/> in<xsl:value-of select="@Discriminator"/>    
      <xsl:if test="not(@Position='Last')">,
</xsl:if>
</xsl:template>
  <xsl:template match="Out/Parameter" mode="function" xml:space="preserve">
    <xsl:text>		</xsl:text>
    <xsl:value-of select="Type"/>
    <xsl:apply-templates select="Name" mode="Out"/> out<xsl:value-of select="@Discriminator"/>          <xsl:if test="not(@Position='Last')">,
</xsl:if>
</xsl:template>
  <xsl:template match="Name" mode="In">
    <xsl:choose>
      <xsl:when test=".='object'">short</xsl:when>
      <xsl:when test=".='boolean'">boolean</xsl:when>
      <xsl:when test=".='id8'">byte</xsl:when>
      <xsl:when test=".='ids8'">byte[]</xsl:when>
      <xsl:when test=".='id16'">short</xsl:when>
      <xsl:when test=".='ids16'">short[]</xsl:when>
      <xsl:when test=".='id32'">int</xsl:when>
      <xsl:when test=".='ids32'">int[]</xsl:when>
      <xsl:when test=".='char'">char</xsl:when>
      <xsl:when test=".='string'">String</xsl:when>
      <xsl:when test=".='strings'">String[]</xsl:when>
      <xsl:when test=".='raw'">byte</xsl:when>
      <xsl:when test=".='binary'">byte[]</xsl:when>
      <xsl:when test=".='binaries'">byte[][]</xsl:when>
      <xsl:when test=".='items8'">Item8[]</xsl:when>
      <xsl:when test=".='items16'">Item16[]</xsl:when>
      <xsl:when test=".='items32'">Item32[]</xsl:when>
      <xsl:otherwise>???</xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="Name" mode="Out">
    <xsl:choose>
      <xsl:when test=".='object'">Short</xsl:when>
      <xsl:when test=".='boolean'">Boolean</xsl:when>
      <xsl:when test=".='id8'">Byte</xsl:when>
      <xsl:when test=".='ids8'">Ids8</xsl:when>
      <xsl:when test=".='id16'">Short</xsl:when>
      <xsl:when test=".='ids16'">Ids16</xsl:when>
      <xsl:when test=".='id32'">Integer</xsl:when>
      <xsl:when test=".='ids32'">Ids32</xsl:when>
      <xsl:when test=".='char'">Character</xsl:when>
      <xsl:when test=".='string'">EString</xsl:when>
      <xsl:when test=".='strings'">String[]</xsl:when>
      <xsl:when test=".='raw'">Byte</xsl:when>
      <xsl:when test=".='binary'">byte[]</xsl:when>
      <xsl:when test=".='binaries'">byte[][]</xsl:when>
      <xsl:when test=".='items8'">Items8</xsl:when>
      <xsl:when test=".='items16'">Items16</xsl:when>
      <xsl:when test=".='items32'">Items32</xsl:when>
      <xsl:otherwise>???</xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="parameter" mode="function" xml:space="preserve">
    <xsl:choose>
      <xsl:when test="@Position='Last'"> )
</xsl:when>
      <xsl:otherwise>,
</xsl:otherwise>
    </xsl:choose>
  </xsl:template>
  <xsl:template match="Commands" mode="name" xml:space="preserve">{<xsl:apply-templates select="Command" mode="name"/>};
</xsl:template>
  <xsl:template match="Command" mode="name" xml:space="preserve">
			"<xsl:value-of select="Name"/>",</xsl:template>
  <xsl:template match="Parameters" mode="instruction" xml:space="preserve">
    <xsl:param name="Base"/>
    <xsl:apply-templates select="In" mode="instruction">
      <xsl:with-param name="Base">
        <xsl:value-of select="$Base"/>
      </xsl:with-param>
    </xsl:apply-templates>
		if ( state = <xsl:value-of select="$Base"/>backend.Send() ) {
<xsl:apply-templates select="Out" mode="instruction">
      <xsl:with-param name="Base">
        <xsl:value-of select="$Base"/>
      </xsl:with-param>
    </xsl:apply-templates>		}

		<xsl:value-of select="$Base"/>backend.TestCompletion();
		return state;
	}
</xsl:template>
  <xsl:template match="In/Parameter" mode="instruction" xml:space="preserve">
    <xsl:param name="Base"/>
    <xsl:text>		</xsl:text>
    <xsl:value-of select="$Base"/>backend.Push<xsl:value-of select="translate(substring(Name,1,1),'obics','OBICS')"/><xsl:value-of select="substring(Name,2)"/>( in<xsl:value-of select="@Discriminator"/> );
</xsl:template>
  <xsl:template match="Out/Parameter" mode="instruction" xml:space="preserve">    <xsl:param name="Base"/>
<xsl:text>			</xsl:text><xsl:value-of select="$Base"/>backend.Pop<xsl:value-of select="translate(substring(Name,1,1),'obics','OBICS')"/><xsl:value-of select="substring(Name,2)"/>( out<xsl:value-of select="@Discriminator"/> );
</xsl:template>
</xsl:stylesheet>