/*
  'bkdacc' library by Claude L. Simon (csimon@epeios.org)
  Requires the 'bkdacc' header file ('bkdacc.h').
  Copyright (C) 2000,2001 Claude L. SIMON (csimon@epeios.org).

  This file is part of the Epeios (http://epeios.org/) project.
  

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, go to http://www.fsf.org/
  or write to the:
  
                        Free Software Foundation, Inc.,
           59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//	$Id: bkdacc.cpp,v 1.2 2001/10/16 11:17:33 csimon Exp $

#define BKDACC__COMPILATION

#include "bkdacc.h"

class bkdacctutor
: public ttr_tutor
{
public:
	bkdacctutor( void )
	: ttr_tutor( BKDACC_NAME )
	{
#ifdef BKDACC_DBG
		Version = BKDACC_VERSION "\b\bD $";
#else
		Version = BKDACC_VERSION;
#endif
		Owner = BKDACC_OWNER;
		Date = "$Date: 2001/10/16 11:17:33 $";
	}
	virtual ~bkdacctutor( void ){}
};

/******************************************************************************/
				  /* do not modify anything above this limit */
				  /*			  unless specified			 */
				  /*******************************************/
/*$BEGIN$*/

using namespace bkdacc;

void bkdacc::backend_access___::TestBackendCasts_()
{
	int i;

	PushHeader( BKDACC_MASTER_OBJECT, BKDACC_MASTER_COMMAND );

	for( i = 0; i < bkdcst::c_amount; i++ )
		flw::PutString( bkdcst::CastsNames[i], *Channel_ );

	Send();

	for( i = 0; i < bkdcst::c_amount; i++ )
		if ( i != Channel_->Get() )
			ERRb();

	TestCompletion();
}

command__ bkdacc::backend_access___::GetBackendDefaultCommand_()
{
	command__ DefaultCommand;

	PushHeader( BKDACC_MASTER_OBJECT, BKDACC_MASTER_COMMAND );
	
	Send();

	flw::Get( *Channel_, DefaultCommand );

	TestCompletion();

	return DefaultCommand;
}

namespace {
	void FillCasts_(
		const bkdcst::cast *Source,
		ids8_ &Dest )
	{
		int i = 0;

		do
			Dest.Add( Source[i] );
		while( Source[i++] != bkdcst::cEnd );

		while( Source[i] != bkdcst::cEnd )
			Dest.Add( Source[i++] );
	}
}

void bkdacc::backend_access___::GetGetCommandsCommand_( command__ DefaultCommand )
{
ERRProlog
	ids8 Casts;
ERRBegin
	Casts.Init();

	FillCasts_( bkdcmd::CommandsParameters[bkdcmd::cGetCommands], Casts );

	PushHeader( BKDACC_MASTER_OBJECT, DefaultCommand );
	PushId16( BKDACC_MASTER_TYPE );	// MasterType;
	PushString( string( bkdcmd::CommandsNames[bkdcmd::cGetCommands] ) );
	PushIds8( Casts );

	Send();

	PopId16( Commands_[bkdcmd::cGetCommands] );

	TestCompletion();
ERRErr
ERREnd
ERREpilog
}

void bkdacc::backend_access___::GetBackendCommands_( void )
{
ERRProlog
	commands_details CommandsDetails;
	command_detail CommandDetail;
	ids16 Commands;
	int i;
ERRBegin
	CommandsDetails.Init();

	for( i = 0; i < bkdcmd::c_amount; i++ ) {
		CommandDetail.Init();
		CommandDetail.Name = bkdcmd::CommandsNames[i];
		FillCasts_( bkdcmd::CommandsParameters[i], CommandDetail.Casts );
		CommandsDetails.Add( CommandDetail );
	}

	Commands.Init();
	GetCommands( BKDACC_MASTER_COMMAND, CommandsDetails, Commands );

	Commands.Read( 0, Commands.Amount(), Commands_ );
ERRErr
ERREnd
ERREpilog
}




/* Although in theory this class is inaccessible to the different modules,
it is necessary to personalize it, or certain compiler would not work properly */

class bkdaccpersonnalization
: public bkdacctutor
{
public:
	bkdaccpersonnalization( void )
	{
		/* place here the actions concerning this library
		to be realized at the launching of the application  */
	}
	~bkdaccpersonnalization( void )
	{
		/* place here the actions concerning this library
		to be realized at the ending of the application  */
	}
};


/*$END$*/
				  /********************************************/
				  /* do not modify anything belove this limit */
				  /*			  unless specified		   	  */
/******************************************************************************/

// 'static' by GNU C++.

static bkdaccpersonnalization Tutor;

ttr_tutor &BKDACCTutor = Tutor;
