/*
  Header for the 'bkdcmd' library by Claude L. Simon (csimon@epeios.org)
  Copyright (C) 2000,2001 Claude L. SIMON (csimon@epeios.org) 

  This file is part of the Epeios (http://epeios.org/) project.
  

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, go to http://www.fsf.org/
  or write to the:
  
                        Free Software Foundation, Inc.,
           59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//	$Id: bkdcmd.h,v 1.3 2001/10/30 14:49:34 csimon Exp $

#ifndef BKDCMD__INC
#define BKDCMD__INC

#define BKDCMD_NAME		"BKDCMD"

#define	BKDCMD_VERSION	"$Revision: 1.3 $"	

#define BKDCMD_OWNER		"the Epeios project (http://epeios.org/)"

#include "ttr.h"

extern class ttr_tutor &BKDCMDTutor;

#if defined( XXX_DBG ) && !defined( BKDCMD_NODBG )
#define BKDCMD_DBG 
#endif

/* Begin of automatic documentation generation part. */

//V $Revision: 1.3 $
//C Claude L. SIMON (csimon@epeios.org)
//R $Date: 2001/10/30 14:49:34 $

/* End of automatic documentation generation part. */

/******************************************************************************/
				  /* do not modify anything above this limit */
				  /*			  unless specified			 */
				  /*******************************************/
/*$BEGIN$*/

/* Addendum to the automatic documentation generation part. */
//D BacKenD CoMmanDs.
/* End addendum to automatic documentation generation part. */


#include "err.h"
#include "flw.h"
#include "bkdcst.h"

//d Version of the commands.
#define BKDCMD_COMMANDS_VERSION	"1"

namespace bkdcmd {
	using namespace bkdcst;

	enum command {
		cSetErrorBreakingStatus,
		cGetErrorBreakingStatus,
		cGetNewObject,
		cGetType,
		cGetCommand,
		cGetCommands,
		cGetTypeAndCommands,
		cRemoveObject,
		cGetLanguagesIDAndName,
		cAbout,
		cDisconnect,
		cGetTypesIDAndPrefixAndName,
		cGetCommandsIDAndName,
		cGetParameters,
		c_amount
	};

	//o Command names.
	extern const char *CommandsNames[bkdcmd::c_amount];

	//o Commands parameters.
	extern const cast *CommandsParameters[bkdcmd::c_amount];

};

/*$END$*/
				  /********************************************/
				  /* do not modify anything belove this limit */
				  /*			  unless specified		   	  */
/******************************************************************************/

#endif
