/*
  'bkdcst' library by Claude L. Simon (csimon@epeios.org)
  Requires the 'bkdcst' header file ('bkdcst.h').
  Copyright (C) 2000,2001 Claude L. SIMON (csimon@epeios.org).

  This file is part of the Epeios (http://epeios.org/) project.
  

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, go to http://www.fsf.org/
  or write to the:
  
                        Free Software Foundation, Inc.,
           59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//	$Id: bkdcst.cpp,v 1.2 2001/10/30 14:49:34 csimon Exp $

#define BKDCST__COMPILATION

#include "bkdcst.h"

class bkdcsttutor
: public ttr_tutor
{
public:
	bkdcsttutor( void )
	: ttr_tutor( BKDCST_NAME )
	{
#ifdef BKDCST_DBG
		Version = BKDCST_VERSION "\b\bD $";
#else
		Version = BKDCST_VERSION;
#endif
		Owner = BKDCST_OWNER;
		Date = "$Date: 2001/10/30 14:49:34 $";
	}
	virtual ~bkdcsttutor( void ){}
};

/******************************************************************************/
				  /* do not modify anything above this limit */
				  /*			  unless specified			 */
				  /*******************************************/
/*$BEGIN$*/

using namespace bkdcst;

// MUST reflect 'bkdcst::cast'
const char *bkdcst::CastsNames[c_amount] = {
	"_end_",
	"Object",
	"Boolean",
	"Id8",
	"Ids8",
	"Id16",
	"Ids16",
	"Id32", 
	"Ids32", 
	"Char",
	"String",
	"Strings",
	"Byte",
	"Binary",
	"Binaries",
	"Items8",
	"Items16",
	"Items32",
	"XItems8",
	"XItems16",
	"XItems32",
	"CommandsDetails",
	"ObjectsReferences"
};

cast bkdcst::GetID( const char *CastName )
{
	int i = 0;

	while( ( i < c_amount ) && strcmp( CastName, CastsNames[i] ) )
		i++;

	if ( i >= c_amount )
		i = cInvalid;

	return (cast)i;
}



/* Although in theory this class is inaccessible to the different modules,
it is necessary to personalize it, or certain compiler would not work properly */

class bkdcstpersonnalization
: public bkdcsttutor
{
public:
	bkdcstpersonnalization( void )
	{
		/* place here the actions concerning this library
		to be realized at the launching of the application  */
	}
	~bkdcstpersonnalization( void )
	{
		/* place here the actions concerning this library
		to be realized at the ending of the application  */
	}
};


/*$END$*/
				  /********************************************/
				  /* do not modify anything belove this limit */
				  /*			  unless specified		   	  */
/******************************************************************************/

// 'static' by GNU C++.

static bkdcstpersonnalization Tutor;

ttr_tutor &BKDCSTTutor = Tutor;
