/*
  'bkdrqm' library by Claude L. Simon (csimon@epeios.org)
  Requires the 'bkdrqm' header file ('bkdrqm.h').
  Copyright (C) 2000,2001 Claude L. SIMON (csimon@epeios.org).

  This file is part of the Epeios (http://epeios.org/) project.
  

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, go to http://www.fsf.org/
  or write to the:
  
                        Free Software Foundation, Inc.,
           59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//	$Id: bkdrqm.cpp,v 1.2 2001/09/10 13:22:33 csimon Exp $

#define BKDRQM__COMPILATION

#include "bkdrqm.h"

class bkdrqmtutor
: public ttr_tutor
{
public:
	bkdrqmtutor( void )
	: ttr_tutor( BKDRQM_NAME )
	{
#ifdef BKDRQM_DBG
		Version = BKDRQM_VERSION "\b\bD $";
#else
		Version = BKDRQM_VERSION;
#endif
		Owner = BKDRQM_OWNER;
		Date = "$Date: 2001/09/10 13:22:33 $";
	}
	virtual ~bkdrqmtutor( void ){}
};

/******************************************************************************/
				  /* do not modify anything above this limit */
				  /*			  unless specified			 */
				  /*******************************************/
/*$BEGIN$*/

using namespace bkdrqm;

void bkdrqm::description_::Init(
	const char *Name,
	const cast *Casts )
{
	int i = 0;
	cast Cast = cInvalid;

	this->Name.Init();
	this->Casts.Init();

	this->Name = Name;

	do
	{
		Cast = Casts[i++];
		this->Casts.Add( Cast );
	} while ( Cast != cEnd );

	while ( ( Cast = Casts[i++] ) != cEnd ) {
		this->Casts.Add( Cast );
	}

#ifdef RQM_DBG
	if ( Array != 0 )
		ERRc();
#endif

}


tym::row__ bkdrqm::descriptions_::Position( const description_ &Description ) const
{
	tym::row__ Position = E_CONTAINER_( description_ )::First();
ERRProlog
	E_CITEM( description_ ) D;
ERRBegin

	D.Init( *this );

	while( ( Position != NONE )
		    && ( ( D( Position ).Name != Description.Name )
		         || ( D( Position ).Casts != Description.Casts ) ) )
		Position = E_CONTAINER_( description_ )::Next( Position );
ERRErr
ERREnd
ERREpilog
	return Position;
}

/* Although in theory this class is inaccessible to the different modules,
it is necessary to personalize it, or certain compiler would not work properly */

class bkdrqmpersonnalization
: public bkdrqmtutor
{
public:
	bkdrqmpersonnalization( void )
	{
		/* place here the actions concerning this library
		to be realized at the launching of the application  */
	}
	~bkdrqmpersonnalization( void )
	{
		/* place here the actions concerning this library
		to be realized at the ending of the application  */
	}
};


/*$END$*/
				  /********************************************/
				  /* do not modify anything belove this limit */
				  /*			  unless specified		   	  */
/******************************************************************************/

// 'static' by GNU C++.

static bkdrqmpersonnalization Tutor;

ttr_tutor &BKDRQMTutor = Tutor;
