/*
  'bch' library by Claude L. Simon (csimon@webmails.com)
  Requires the 'bch' header file ('bch.h').
  Copyright (C) 2000,2001 Claude L. SIMON (csimon@webmails.com).

  This file is part of the Epeios (http://epeios.org/) project.
  

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, go to http://www.fsf.org/
  or write to the:
  
                        Free Software Foundation, Inc.,
           59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//	$Id: bch.cpp,v 1.14 2001/07/27 09:48:13 csimon Exp $

#define BCH__COMPILATION

#include "bch.h"

class bchtutor
: public ttr_tutor
{
public:
	bchtutor( void )
	: ttr_tutor( BCH_NAME )
	{
#ifdef BCH_DBG
		Version = BCH_VERSION "\b\bD $";
#else
		Version = BCH_VERSION;
#endif
		Owner = BCH_OWNER;
		Date = "$Date: 2001/07/27 09:48:13 $";
	}
	virtual ~bchtutor( void ){}
};

/******************************************************************************/
				  /* do not modify anything above this limit */
				  /*			  unless specified			 */
				  /*******************************************/
/*$BEGIN$*/

namespace bch {
}

/* Although in theory this class is inaccessible to the different modules,
it is necessary to personalize it, or certain compiler would not work properly */

class bchpersonnalization
: public bchtutor
{
public:
	bchpersonnalization( void )
	{
		/* place here the actions concerning this library
		to be realized at the launching of the application  */
	}
	~bchpersonnalization( void )
	{
		/* place here the actions concerning this library
		to be realized at the ending of the application  */
	}
};


/*$END$*/
				  /********************************************/
				  /* do not modify anything belove this limit */
				  /*			  unless specified		   	  */
/******************************************************************************/

// 'static' by GNU C++.

static bchpersonnalization Tutor;

ttr_tutor &BCHTutor = Tutor;
