/*
  'lst' library by Claude L. Simon (simon@epeios.org)
  Requires the 'lst' header file ('lst.h').
  Copyright (C) 2000,2001 Claude L. SIMON (simon@epeios.org).

  This file is part of the Epeios (http://www.epeios.org/) project.
  

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, go to http://www.fsf.org/
  or write to the:
  
                        Free Software Foundation, Inc.,
           59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//	$Id: lst.cpp,v 1.13 2001/06/16 09:11:21 csimon Exp $

#define LST__COMPILATION

#include "lst.h"

class lsttutor
: public ttr_tutor
{
public:
	lsttutor( void )
	: ttr_tutor( LST_NAME )
	{
#ifdef LST_DBG
		Version = LST_VERSION "\b\bD $";
#else
		Version = LST_VERSION;
#endif
		Owner = LST_OWNER;
		Date = "$Date: 2001/06/16 09:11:21 $";
	}
	virtual ~lsttutor( void ){}
};

/******************************************************************************/
				  /* do not modify anything above this limit */
				  /*			  unless specified			 */
				  /*******************************************/
/*$BEGIN$*/

// Retourne vrai si 'Element' existe dans la liste.
bso::bool__ lst::Existe_(
	epeios::row_t__ Position,
	const stk::E_STACK_( epeios::row_t__ ) &Libres )
{
	tym::row_t__ Nombre = Libres.Amount();
	bso::bool__ Trouve = false;

	while ( Nombre-- && !( Trouve = ( Libres( Nombre ) == Position ) ) );

	return !Trouve;
}


// Retourne l'lment succdant  'Element', ou LST_INEXISTANT si inexistant.
epeios::row_t__ lst::Successeur_(
	epeios::row_t__ Element,
	epeios::size__ Amount,
	const stk::E_STACK_( epeios::row_t__ ) &Libres )
{
	while( ( ++Element < Amount ) && !Existe_( Element, Libres ) );

	if ( Element >= Amount )
		return NONE;
	else
		return Element;
}

// Retourne l'lment prcdent 'Element', ou LST_INEXISTANT si inexistant.
epeios::row_t__ lst::Predecesseur_(
	tym::row_t__ Element,
	const stk::E_STACK_( epeios::row_t__ ) &Libres )
{
	bso::bool__ Trouve = false;

	while( ( Element > 0 ) && !( Trouve = Existe_( --Element, Libres ) ) );

	if ( Trouve )
		return Element;
	else
		return NONE;
}

/* Although in theory this class is inaccessible to the different modules,
it is necessary to personalize it, or certain compiler would not work properly */
class lstpersonnalization
: public lsttutor
{
public:
	lstpersonnalization( void )
	{
		/* place here the actions concerning this library
		to be realized at the launching of the application  */
	}
	~lstpersonnalization( void )
	{
		/* place here the actions concerning this library
		to be realized at the ending of the application  */
	}
};


/*$END$*/
				  /********************************************/
				  /* do not modify anything belove this limit */
				  /*			  unless specified		   	  */
/******************************************************************************/

// 'static' by GNU C++.

static lstpersonnalization Tutor;

ttr_tutor &LSTTutor = Tutor;
