/*
  'tmcbsc' library by Claude L. Simon (epeios@epeios.org)
  Requires the 'tmcbsc' header file ('tmcbsc.h').
  Copyright (C) 2000 Claude L. SIMON (epeios@epeios.org).

  This file is part of the Epeios (http://www.epeios.org/) project.
  

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, go to http://www.fsf.org/
  or write to the:
  
                        Free Software Foundation, Inc.,
           59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//	$Id: tmcbsc.cpp,v 1.2 2000/12/04 21:34:59 csimon Exp $

#define TMCBSC__COMPILATION

#include "tmcbsc.h"

class tmcbsctutor
: public ttr_tutor
{
public:
	tmcbsctutor( void )
	: ttr_tutor( TMCBSC_NAME )
	{
#ifdef TMCBSC_DBG
		Version = TMCBSC_VERSION "\b\bD $";
#else
		Version = TMCBSC_VERSION;
#endif
		Owner = TMCBSC_OWNER;
		Date = "$Date: 2000/12/04 21:34:59 $";
	}
	virtual ~tmcbsctutor( void ){}
};

/******************************************************************************/
				  /* do not modify anything above this limit */
				  /*			  unless specified			 */
				  /*******************************************/
/*$BEGIN$*/

/* Although in theory this class is inaccessible to the different modules,
it is necessary to personalize it, or certain compiler would not work properly */
class tmcbscpersonnalization
: public tmcbsctutor
{
public:
	tmcbscpersonnalization( void )
	{
		/* place here the actions concerning this library
		to be realized at the launching of the application  */
	}
	~tmcbscpersonnalization( void )
	{
		/* place here the actions concerning this library
		to be realized at the ending of the application  */
	}
};


/*$END$*/
				  /********************************************/
				  /* do not modify anything belove this limit */
				  /*			  unless specified		   	  */
/******************************************************************************/

// 'static' by GNU C++.

static tmcbscpersonnalization Tutor;

ttr_tutor &TMCBSCTutor = Tutor;
