/*
  Header for the 'tmcbsc' library by Claude L. Simon (epeios@epeios.org)
  Copyright (C) 2000 Claude L. SIMON (epeios@epeios.org) 

  This file is part of the Epeios (http://www.epeios.org/) project.
  

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, go to http://www.fsf.org/
  or write to the:
  
                        Free Software Foundation, Inc.,
           59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//	$Id: tmcbsc.h,v 1.2 2000/12/04 21:34:59 csimon Exp $

#ifndef TMCBSC__INC
#define TMCBSC__INC

#define TMCBSC_NAME		"TMCBSC"

#define	TMCBSC_VERSION	"$Revision: 1.2 $"	

#define TMCBSC_OWNER		"the Epeios project (http://www.epeios.org/)"

#include "ttr.h"

extern class ttr_tutor &TMCBSCTutor;

#if defined( XXX_DBG ) && !defined( TMCBSC_NODBG )
#define TMCBSC_DBG 
#endif

/* Begin of automatic documentation generation part. */

//V $Revision: 1.2 $
//C Claude L. SIMON (epeios@epeios.org)
//R $Date: 2000/12/04 21:34:59 $

/* End of automatic documentation generation part. */

/******************************************************************************/
				  /* do not modify anything above this limit */
				  /*			  unless specified			 */
				  /*******************************************/
/*$BEGIN$*/

#include "err.h"
#include "bso.h"

struct tmcbsc
{
	//e standards.
	enum standard
	{
		//i 25 i/s
		s25,
		//i 30 i/s non drop frame
		s30NDF,
		//i 30 i/s drop frame
		s30DF,
		//i amount of standards.
		s_amount
	};
	//e formats.
	enum format {
		//i h:m:s-i
		fHMSI,
		//i m's"i
		fMSI,
		//i amount of formats.
		f_amount
	};
};


/*$END$*/
				  /********************************************/
				  /* do not modify anything belove this limit */
				  /*			  unless specified		   	  */
/******************************************************************************/

#endif
