/*
  Header for the 'tmcbsc_' library by Claude L. Simon (epeios@epeios.org)
  Copyright (C) 2000 Claude L. SIMON (epeios@epeios.org) 

  This file is part of the Epeios (http://www.epeios.org/) project.
  

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, go to http://www.fsf.org/
  or write to the:
  
                        Free Software Foundation, Inc.,
           59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//	$Id: tmcbsc_.h,v 1.7 2001/07/04 08:13:56 uid30395 Exp $

#ifndef TMCBSC___INC
#define TMCBSC___INC

#define TMCBSC__NAME		"TMCBSC_"

#define	TMCBSC__VERSION	"$Revision: 1.7 $"	

#define TMCBSC__OWNER		"the Epeios project (http://www.epeios.org/)"

#include "ttr.h"

extern class ttr_tutor &TMCBSC_Tutor;

#if defined( XXX_DBG ) && !defined( TMCBSC__NODBG )
#define TMCBSC__DBG 
#endif

/* Begin of automatic documentation generation part. */

//V $Revision: 1.7 $
//C Claude L. SIMON (epeios@epeios.org)
//R $Date: 2001/07/04 08:13:56 $

/* End of automatic documentation generation part. */

/******************************************************************************/
				  /* do not modify anything above this limit */
				  /*			  unless specified			 */
				  /*******************************************/
/*$BEGIN$*/

/* Addendum to the automatic documentation generation part. */
//D TiMeCode BaSiCs (backend objects).
/* End addendum to automatic documentation generation part. */


#include "err.h"
#include "flw.h"
#include "bkdmng.h"
#include "tmcbsc.h"

namespace tmcbsc_ {

	enum command {
		cGetStandards,
		cGetStandardLabel,
		cGetFormats,
		cGetFormatLabel,
		c_amount };

	//o Commands names.
	extern const char *CommandsNames[c_amount];

	//o Commands parameters.
	extern const bkdcst::cast *CommandsParameters[c_amount];

	//f Inform 'Backend' about orphans commands.
	void Inform( bkdmng::backend_ &Backend );

};

/*$END$*/
				  /********************************************/
				  /* do not modify anything belove this limit */
				  /*			  unless specified		   	  */
/******************************************************************************/

#endif
