/*
  Header for the 'tmcdrt' library by Claude L. Simon (epeios@epeios.org)
  Copyright (C) 2000 Claude L. SIMON (epeios@epeios.org) 

  This file is part of the Epeios (http://www.epeios.org/) project.
  

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, go to http://www.fsf.org/
  or write to the:
  
                        Free Software Foundation, Inc.,
           59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//	$Id: tmcdrt.h,v 1.3 2001/05/13 19:44:46 csimon Exp $

#ifndef TMCDRT__INC
#define TMCDRT__INC

#define TMCDRT_NAME		"TMCDRT"

#define	TMCDRT_VERSION	"$Revision: 1.3 $"	

#define TMCDRT_OWNER		"the Epeios project (http://www.epeios.org/)"

#include "ttr.h"

extern class ttr_tutor &TMCDRTTutor;

#if defined( XXX_DBG ) && !defined( TMCDRT_NODBG )
#define TMCDRT_DBG 
#endif

/* Begin of automatic documentation generation part. */

//V $Revision: 1.3 $
//C Claude L. SIMON (epeios@epeios.org)
//R $Date: 2001/05/13 19:44:46 $

/* End of automatic documentation generation part. */

/******************************************************************************/
				  /* do not modify anything above this limit */
				  /*			  unless specified			 */
				  /*******************************************/
/*$BEGIN$*/

#include "err.h"
#include "tmctmc.h"

namespace tmcdrt {

	//c A duration.
	class duration__
	{
		tmctmc::images_time_code__ Debut_, Fin_;
	public:
		duration__(
			tmctmc::images_time_code__ Begin = (tmctmc::titc__)0,
			tmctmc::images_time_code__ End = (tmctmc::titc__)0 )
		{
			Debut_ = Begin;
			Fin_ = End;
		}
		//f 'Begin' becomes the begin time code.
		void SetBegin(	tmctmc::images_time_code__ Begin )
		{
			Debut_ = Begin;
		}
		//f Return the begin of the time code.
		tmctmc::images_time_code__ GetBegin( void )
		{
			return Debut_;
		}
		//f 'End' becomes the end time code.
		void SetEnd( tmctmc::images_time_code__ End )
		{
			Fin_ = End;
		}
		//f Return the end of the time code.
		tmctmc::images_time_code__ GetEnd( void )
		{
			return Fin_;
		}
		//f Return the value of the duration.
		tmctmc::images_time_code__ Result( void )
		{
			return (tmctmc::titc__)( (tmctmc::titc__)Fin_ - (tmctmc::titc__)Debut_ );
		}
		//f Return true if duration < 0.
		bso::bool__ Sign( void )
		{
			return ( Result() < 0 );
		}
		void Init( void )
		{
			Debut_ = 0;
			Fin_ = 0;
		}
	};
}



/*$END$*/
				  /********************************************/
				  /* do not modify anything belove this limit */
				  /*			  unless specified		   	  */
/******************************************************************************/

#endif
