/*
  Header for the 'tmcdrt_' library by Claude L. Simon (simon@epeios.org)
  Copyright (C) 2000 Claude L. SIMON (simon@epeios.org) 

  This file is part of the Epeios (http://www.epeios.org/) project.
  

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, go to http://www.fsf.org/
  or write to the:
  
                        Free Software Foundation, Inc.,
           59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//	$Id: tmcdrt_.h,v 1.7 2001/10/30 14:52:51 csimon Exp $

#ifndef TMCDRT___INC
#define TMCDRT___INC

#define TMCDRT__NAME		"TMCDRT_"

#define	TMCDRT__VERSION	"$Revision: 1.7 $"	

#define TMCDRT__OWNER		"the Epeios project (http://www.epeios.org/)"

#include "ttr.h"

extern class ttr_tutor &TMCDRT_Tutor;

#if defined( XXX_DBG ) && !defined( TMCDRT__NODBG )
#define TMCDRT__DBG 
#endif

/* Begin of automatic documentation generation part. */

//V $Revision: 1.7 $
//C Claude L. SIMON (simon@epeios.org)
//R $Date: 2001/10/30 14:52:51 $

/* End of automatic documentation generation part. */

/******************************************************************************/
				  /* do not modify anything above this limit */
				  /*			  unless specified			 */
				  /*******************************************/
/*$BEGIN$*/

/* Addendum to the automatic documentation generation part. */
//D tiMe Code DuRation (backend objects).
/* End addendum to automatic documentation generation part. */


#include "err.h"
#include "flw.h"
#include "tmcdrt.h"
#include "bkdmng.h"

#define TMCDRT__DURATION_TYPE_PREFIX	"tmc"
#define TMCDRT__DURATION_TYPE_NAME		"duration"

namespace tmcdrt_ {

	using tol::object_;

	class duration
	: public object_<tmcdrt::duration__>
	{
	public:
		duration( s &S )
		: object_<tmcdrt::duration__>( S )
		{}
		void HANDLE(
			bkdmng::backend &Backend,
			bkdmng::untyped_module &Module,
			bkdmng::command__ Command,
			bkdmng::request_manager___ &Request,
			void *UP );
		static void NOTIFY( bkdmng::untyped_module &Module );
		static const char *PREFIX;
		static const char *NAME;
		void Init( void )
		{
			object_<tmcdrt::duration__>::operator()().Init();
		}
	};
}

/*$END$*/
				  /********************************************/
				  /* do not modify anything belove this limit */
				  /*			  unless specified		   	  */
/******************************************************************************/

#endif
