/*
  'tmcset' library by Claude L. Simon (epeios@epeios.org)
  Requires the 'tmcset' header file ('tmcset.h').
  Copyright (C) 2000 Claude L. SIMON (epeios@epeios.org).

  This file is part of the Epeios (http://www.epeios.org/) project.
  

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, go to http://www.fsf.org/
  or write to the:
  
                        Free Software Foundation, Inc.,
           59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//	$Id: tmcset.cpp,v 1.4 2001/02/06 17:03:28 csimon Exp $

#define TMCSET__COMPILATION

#include "tmcset.h"

class tmcsettutor
: public ttr_tutor
{
public:
	tmcsettutor( void )
	: ttr_tutor( TMCSET_NAME )
	{
#ifdef TMCSET_DBG
		Version = TMCSET_VERSION "\b\bD $";
#else
		Version = TMCSET_VERSION;
#endif
		Owner = TMCSET_OWNER;
		Date = "$Date: 2001/02/06 17:03:28 $";
	}
	virtual ~tmcsettutor( void ){}
};

/******************************************************************************/
				  /* do not modify anything above this limit */
				  /*			  unless specified			 */
				  /*******************************************/
/*$BEGIN$*/

using namespace tmcset;

tmctmc::images_time_code__ tmcset::duration_set_::Total( void )
{
	epeios::row__ Courant = E_IQUEUE_::First();
	tmctmc::images_time_code__ Somme( 0 );

	while ( Courant != NONE )
	{
		if ( Operations.Read( Courant ) )
			Somme -= Durations( Courant ).Result();
		else
			Somme += Durations( Courant ).Result();

		Courant = E_IQUEUE_::Next( Courant );
	}

	return Somme;
}



/* Although in theory this class is inaccessible to the different modules,
it is necessary to personalize it, or certain compiler would not work properly */
class tmcsetpersonnalization
: public tmcsettutor
{
public:
	tmcsetpersonnalization( void )
	{
		/* place here the actions concerning this library
		to be realized at the launching of the application  */
	}
	~tmcsetpersonnalization( void )
	{
		/* place here the actions concerning this library
		to be realized at the ending of the application  */
	}
};


/*$END$*/
				  /********************************************/
				  /* do not modify anything belove this limit */
				  /*			  unless specified		   	  */
/******************************************************************************/

// 'static' by GNU C++.

static tmcsetpersonnalization Tutor;

ttr_tutor &TMCSETTutor = Tutor;
