/*
  Header for the 'tmctmc_' library by Claude L. Simon (simon@epeios.org)
  Copyright (C) 2000 Claude L. SIMON (simon@epeios.org) 

  This file is part of the Epeios (http://www.epeios.org/) project.
  

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, go to http://www.fsf.org/
  or write to the:
  
                        Free Software Foundation, Inc.,
           59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

//	$Id: tmctmc_.h,v 1.10 2001/10/30 14:52:51 csimon Exp $

#ifndef TMCTMC___INC
#define TMCTMC___INC

#define TMCTMC__NAME		"TMCTMC_"

#define	TMCTMC__VERSION	"$Revision: 1.10 $"	

#define TMCTMC__OWNER		"the Epeios project (http://www.epeios.org/)"

#include "ttr.h"

extern class ttr_tutor &TMCTMC_Tutor;

#if defined( XXX_DBG ) && !defined( TMCTMC__NODBG )
#define TMCTMC__DBG 
#endif

/* Begin of automatic documentation generation part. */

//V $Revision: 1.10 $
//C Claude L. SIMON (simon@epeios.org)
//R $Date: 2001/10/30 14:52:51 $

/* End of automatic documentation generation part. */

/******************************************************************************/
				  /* do not modify anything above this limit */
				  /*			  unless specified			 */
				  /*******************************************/
/*$BEGIN$*/

/* Addendum to the automatic documentation generation part. */
//D TiMeCode TiMeCode (backend objects).
/* End addendum to automatic documentation generation part. */


#include "err.h"
#include "flw.h"
#include "bkdmng.h"
#include "tmctmc.h"

#define TMCTMC__TIMECODE_TYPE_PREFIX	"tmc"
#define TMCTMC__TIMECODE_TYPE_NAME		"timecode"

namespace tmctmc_ {

	using tol::object_;
	
	//c The class to interface 'tmc_time_code' objects.
	class timecode
	: public object_<tmctmc::hour_time_code__>
	{
	public:
		timecode( s &S )
		: tol::object_<tmctmc::hour_time_code__>( S )
		{}
		void HANDLE(
			bkdmng::backend &Backend,
			bkdmng::untyped_module &Module,
			bkdmng::command__ Command,
			bkdmng::request_manager___ &Request,
			void *UP );
		static void NOTIFY( bkdmng::untyped_module &Module );
		static const char *PREFIX;
		static const char *NAME;
		// Initialisation
		void Init( void )
		{
			object_<tmctmc::hour_time_code__>::operator()().H( 0 );
			object_<tmctmc::hour_time_code__>::operator()().M( 0 );
			object_<tmctmc::hour_time_code__>::operator()().S( 0 );
			object_<tmctmc::hour_time_code__>::operator()().I( 0 );
		}
	};
};

/*$END$*/
				  /********************************************/
				  /* do not modify anything belove this limit */
				  /*			  unless specified		   	  */
/******************************************************************************/

#endif
