// MsgViewerDoc.cpp : implementation of the CMsgViewerDoc class
//

#include "stdafx.h"
#include "MsgViewer.h"

#include "MsgViewerDoc.h"
#include <mimepp/mimepp.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMsgViewerDoc

IMPLEMENT_DYNCREATE(CMsgViewerDoc, CDocument)

BEGIN_MESSAGE_MAP(CMsgViewerDoc, CDocument)
    //{{AFX_MSG_MAP(CMsgViewerDoc)
        // NOTE - the ClassWizard will add and remove mapping macros here.
        //    DO NOT EDIT what you see in these blocks of generated code!
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMsgViewerDoc construction/destruction

CMsgViewerDoc::CMsgViewerDoc()
{
    mMessage = 0;
    mCurrentObjectId = -1;
}

CMsgViewerDoc::~CMsgViewerDoc()
{
}

BOOL CMsgViewerDoc::OnNewDocument()
{
    if (!CDocument::OnNewDocument())
        return FALSE;

    // TODO: add reinitialization code here
    // (SDI documents will reuse this document)

    return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CMsgViewerDoc serialization

void CMsgViewerDoc::Serialize(CArchive& ar)
{
    if (ar.IsStoring())
    {
        // TODO: add storing code here
    }
    else
    {
        CString line;
        DwString str;
        BOOL ret;
        while (1) {
            ret = ar.ReadString(line);
            if (!ret) {
                break;
            }
            str += (LPCTSTR) line;
            str += "\r\n";
        }
        if (!mMessage) {
            mMessage = new DwMessage;
        }
        mMessage->FromString(str);
        mMessage->Parse();
    }
}

/////////////////////////////////////////////////////////////////////////////
// CMsgViewerDoc diagnostics

#ifdef _DEBUG
void CMsgViewerDoc::AssertValid() const
{
    CDocument::AssertValid();
}

void CMsgViewerDoc::Dump(CDumpContext& dc) const
{
    CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMsgViewerDoc commands

DwMessage* CMsgViewerDoc::GetMessage() const
{
    return mMessage;
}


int CMsgViewerDoc::GetCurrentObjectId() const
{
    return mCurrentObjectId;
}


void CMsgViewerDoc::SetCurrentObjectId(int aId)
{
    mCurrentObjectId = aId;
}


DwMessageComponent* CMsgViewerDoc::FindComponentById(int aId) const
{
    if (mMessage == 0) {
        return 0;
    }
    DwMessageComponent* ret = FindComponentByIdRecurse(mMessage, aId);
    return ret;
}


DwMessageComponent* CMsgViewerDoc::FindComponentByIdRecurse(
    DwMessageComponent* aCmp, int aId) const
{
    if (aCmp->ObjectId() == aId) {
        return aCmp;
    }
    switch (aCmp->ClassId()) {
        case DwMessageComponent::kCidAddressList: {
            DwAddressList* addrList = (DwAddressList*) aCmp;
            int numAddresses = addrList->NumAddresses();
            for (int i=0; i < numAddresses; ++i) {
                DwAddress* addr = &addrList->AddressAt(i);
                DwMessageComponent* ret = FindComponentByIdRecurse(addr, aId);
                if (ret != 0) {
                    return ret;
                }
            }
            return 0;
        }
        case DwMessageComponent::kCidBody: {
            DwBody* body = (DwBody*) aCmp;
            DwMessageComponent* ret = 0;
            int numBodyParts = body->NumBodyParts();
            for (int i=0; i < numBodyParts; ++i) {
                DwBodyPart* bodyPart = &body->BodyPartAt(i);
                ret = FindComponentByIdRecurse(bodyPart, aId);
                if (ret != 0) {
                    return ret;
                }
            }
            DwMessage* msg = body->Message();
            if (msg) {
                ret = FindComponentByIdRecurse(msg, aId);
                if (ret != 0) {
                    return ret;
                }
            }
            return 0;
        }
        case DwMessageComponent::kCidBodyPart:
        case DwMessageComponent::kCidMessage:
        case DwMessageComponent::kCidEntity: {
            DwEntity* entity = (DwEntity*) aCmp;
            DwHeaders& headers = entity->Headers();
            DwMessageComponent* ret;
            ret = FindComponentByIdRecurse(&headers, aId);
            if (ret != 0) {
                return ret;
            }
            DwBody& body = entity->Body();
            ret = FindComponentByIdRecurse(&body, aId);
            return ret;
        }
        case DwMessageComponent::kCidField: {
            DwField* field = (DwField*) aCmp;
            DwFieldBody* fieldBody = field->FieldBody();
            DwMessageComponent* ret;
            ret = FindComponentByIdRecurse(fieldBody, aId);
            return ret;
        }
        case DwMessageComponent::kCidGroup: {
            DwGroup* group = (DwGroup*) aCmp;
            DwMailboxList& mboxList = group->MailboxList();
            DwMessageComponent* ret;
            ret = FindComponentByIdRecurse(&mboxList, aId);
            return ret;
        }
        case DwMessageComponent::kCidHeaders: {
            DwHeaders* headers = (DwHeaders*) aCmp;
            int numFields = headers->NumFields();
            for (int i=0; i < numFields; ++i) {
                DwField* field = &headers->FieldAt(i);
                DwMessageComponent* ret = FindComponentByIdRecurse(field, aId);
                if (ret != 0) {
                    return ret;
                }
            }
            return 0;
        }
        case DwMessageComponent::kCidMailboxList: {
            DwMailboxList* mboxList = (DwMailboxList*) aCmp;
            int numMailboxes = mboxList->NumMailboxes();
            for (int i=0; i < numMailboxes; ++i) {
                DwMailbox* mbox = &mboxList->MailboxAt(i);
                DwMessageComponent* ret = FindComponentByIdRecurse(mbox, aId);
                if (ret != 0) {
                    return ret;
                }
            }
            return 0;
        }
        case DwMessageComponent::kCidMediaType: {
            DwMediaType* type = (DwMediaType*) aCmp;
            int numParameters = type->NumParameters();
            for (int i=0; i < numParameters; ++i) {
                DwParameter* param = &type->ParameterAt(i);
                DwMessageComponent* ret = FindComponentByIdRecurse(param, aId);
                if (ret != 0) {
                    return ret;
                }
            }
            return 0;
        }
        case DwMessageComponent::kCidDispositionType: {
            DwDispositionType* type = (DwDispositionType*) aCmp;
            int numParameters = type->NumParameters();
            for (int i=0; i < numParameters; ++i) {
                DwParameter* param = &type->ParameterAt(i);
                DwMessageComponent* ret = FindComponentByIdRecurse(param, aId);
                if (ret != 0) {
                    return ret;
                }
            }
            return 0;
        }
        case DwMessageComponent::kCidText: {
            DwText* text = (DwText*) aCmp;
            int numEncodedWords = text->NumEncodedWords();
            for (int i=0; i < numEncodedWords; ++i) {
                DwEncodedWord* word = &text->EncodedWordAt(i);
                DwMessageComponent* ret = FindComponentByIdRecurse(word, aId);
                if (ret != 0) {
                    return ret;
                }
            }
            return 0;
        }
    }
    return 0;
}
