// MsgViewerTextView.cpp : implementation file
//

#include "stdafx.h"
#include "MsgViewer.h"
#include "MsgViewerTextView.h"
#include <mimepp/mimepp.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMsgViewerTextView

IMPLEMENT_DYNCREATE(CMsgViewerTextView, CEditView)

CMsgViewerTextView::CMsgViewerTextView()
{
}

CMsgViewerTextView::~CMsgViewerTextView()
{
}


BEGIN_MESSAGE_MAP(CMsgViewerTextView, CEditView)
    //{{AFX_MSG_MAP(CMsgViewerTextView)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMsgViewerTextView drawing

void CMsgViewerTextView::OnDraw(CDC* pDC)
{
    CDocument* pDoc = GetDocument();
    // TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CMsgViewerTextView diagnostics

#ifdef _DEBUG
void CMsgViewerTextView::AssertValid() const
{
    CEditView::AssertValid();
}

void CMsgViewerTextView::Dump(CDumpContext& dc) const
{
    CEditView::Dump(dc);
}

CMsgViewerDoc* CMsgViewerTextView::GetDocument() // non-debug version is inline
{
    ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMsgViewerDoc)));
    return (CMsgViewerDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMsgViewerTextView message handlers

void CMsgViewerTextView::OnInitialUpdate() 
{
    CEditView::OnInitialUpdate();
    
    CMsgViewerDoc* pDoc = GetDocument();
    ASSERT_VALID(pDoc);

    DwMessage* msg = pDoc->GetMessage();
    if (msg == 0) {
        return;
    }
    const char* str = msg->AsString().c_str();
    GetEditCtrl().SetWindowText(str);
}

void CMsgViewerTextView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
    CMsgViewerDoc* doc = GetDocument();
    if (doc == 0) {
        return;
    }
    int objId = doc->GetCurrentObjectId();
    if (objId == -1) {
        return;
    }
    DwMessageComponent* cmp;
    cmp = doc->FindComponentById(objId);
    if (cmp == 0) {
        GetEditCtrl().SetWindowText("");
        return;
    }
    const char* str = cmp->AsString().c_str();
    GetEditCtrl().SetWindowText(str);
}

int CMsgViewerTextView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CEditView::OnCreate(lpCreateStruct) == -1)
		return -1;
	CClientDC dc(this);
	int fontHeight = -((dc.GetDeviceCaps(LOGPIXELSY)*9)/72);
	mFont.CreateFont(fontHeight, 0, 0, 0, FW_NORMAL, 0, 0, 0,
		DEFAULT_CHARSET, OUT_CHARACTER_PRECIS, CLIP_CHARACTER_PRECIS,
		DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, "Courier New");
	GetEditCtrl().SetFont(&mFont, FALSE);
	return 0;
}
