// MsgViewerTreeView.h : interface of the CMsgViewerTreeView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MSGVIEWERTREEVIEW_H__C88EA6A5_354C_11D1_A9C9_000000000000__INCLUDED_)
#define AFX_MSGVIEWERTREEVIEW_H__C88EA6A5_354C_11D1_A9C9_000000000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include <mimepp/mimepp.h>

class CMsgViewerDoc;


class CMsgViewerTreeView : public CTreeView
{
protected:
	CMsgViewerTreeView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CMsgViewerTreeView)

// Attributes
public:
	CMsgViewerDoc* GetDocument();

// Operations
public:

    void ExpandEntity(DwEntity* aEntity, HTREEITEM aParentItem);
    void ExpandHeaders(DwHeaders* aHeaders, HTREEITEM aParentItem);
    void ExpandBody(DwBody* aBody, HTREEITEM aParentItem);
    void ExpandField(DwField* aField, HTREEITEM aParentItem);
    void ExpandAddressList(DwAddressList* aAddrList, HTREEITEM aParentItem);
    void ExpandMailboxList(DwMailboxList* aMboxList, HTREEITEM aParentItem);
    void ExpandMediaType(DwMediaType* aType, HTREEITEM aParentItem);
    void ExpandGroup(DwGroup* aAddr, HTREEITEM aParentItem);
    void ExpandDispositionType(DwDispositionType* aType, HTREEITEM aParentItem);
    void ExpandText(DwText* aText, HTREEITEM aParentItem);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMsgViewerTreeView)
	public:
	virtual void OnInitialUpdate();
	protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CMsgViewerTreeView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
protected:
	//{{AFX_MSG(CMsgViewerTreeView)
	afx_msg void OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MSGVIEWERTREEVIEW_H__C88EA6A5_354C_11D1_A9C9_000000000000__INCLUDED_)
